#include<bits/stdc++.h>
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int MAXN = 2e3 + 3;

int N;
bool A[MAXN][MAXN];

int check(bool DEBUG = false){
    int ret = 0;
    vector<int> dp(N);
    for(int i = 0; i < N; i ++){
        for(int j = 0; j < N; j ++){
            dp[j] = (A[i][j] ? dp[j] + 1 : 0);
        }
        stack<pair<int, int>> st;
        for(int j = 0; j < N; j ++){
            int acc = 1;
            if(DEBUG) cout << "alone " << acc << " * " << dp[j] << endl;
            ret = max(ret, acc * dp[j]);
            while(!st.empty() && st.top().fr >= dp[j]){
                acc += st.top().sc;
                if(DEBUG) cout << "instack " << acc << " * " << dp[j] << endl;
                ret = max(ret, acc * dp[j]);
                st.pop();
            }
            st.push({dp[j], acc});
        }
        int acc = 0;
        while(!st.empty()){
            acc += st.top().sc;
            if(DEBUG) cout << "emptying " << acc << " * " << st.top().fr << endl;
            ret = max(ret, acc * st.top().fr);
            st.pop();
        }
    }
    return ret;
}

int main(){
    cin >> N;
    for(int i = 0; i < N; i ++){
        string inp; cin >> inp;
        for(int j = 0; j < N; j ++){
            A[i][j] = inp[j] - '0';
        }
    }
    int ans = 0;
    for(int a = 0; a < N; a ++) for(int b = a; b < N; b ++) for(int c = 0; c < N; c ++) for(int d = c; d < N; d ++){
        for(int i = a; i <= b; i ++){
            for(int j = c; j <= d; j ++){
                A[i][j] ^= 1;
            }
        }

        ans = max(ans, check());

        for(int i = a; i <= b; i ++){
            for(int j = c; j <= d; j ++){
                A[i][j] ^= 1;
            }
        }
    }
    ans = max(ans, check());
    cout << ans << endl;
}
