#include<bits/stdc++.h>
#define fr first
#define sc second
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int MAXN = 2e3 + 3;

int N, up0[MAXN][MAXN], down0[MAXN][MAXN], up1[MAXN][MAXN], down1[MAXN][MAXN];
bool A[MAXN][MAXN];

int check(vector<int> &dp, bool DEBUG = false){
    int ret = 0;
    stack<pair<int, int>> st;
    for(int j = 0; j < dp.size(); j ++){
        int acc = 0;
        if(DEBUG) cout << "alone " << acc << " * " << dp[j] << endl;
        ret = max(ret, dp[j]);
        while(!st.empty() && st.top().fr >= dp[j]){
            acc += st.top().sc;
            if(DEBUG) cout << "instack " << acc << " * " << st.top().fr << endl;
            ret = max(ret, acc * st.top().fr);
            st.pop();
        }
        st.push({dp[j], acc + 1});
    }
    int acc = 0;
    while(!st.empty()){
        acc += st.top().sc;
        if(DEBUG) cout << "emptying " << acc << " * " << st.top().fr << endl;
        ret = max(ret, acc * st.top().fr);
        st.pop();
    }
    return ret;
}

int main(){
    vector<int> az = {1};
    cin >> N;
    for(int i = 0; i < N; i ++){
        string inp; cin >> inp;
        for(int j = 0; j < N; j ++){
            A[i][j] = inp[j] - '0';
        }
    }
    for(int i = 0; i < N; i ++){
        for(int j = 0; j < N; j ++){
            if(A[i][j]) up0[i][j] = 0;
            else up0[i][j] = (i ? up0[i - 1][j] : 0) + 1;
        }
    }

    for(int i = 0; i < N; i ++){
        for(int j = 0; j < N; j ++){
            if(!A[i][j]) up1[i][j] = 0;
            else up1[i][j] = (i ? up1[i - 1][j] : 0) + 1;
        }
    }
    for(int i = N - 1; i >= 0; i --){
        for(int j = 0; j < N; j ++){
            if(A[i][j]) down0[i][j] = 0;
            else down0[i][j] = (i == N - 1 ? 0 : down0[i + 1][j]) + 1;
        }
    }
    for(int i = N - 1; i >= 0; i --){
        for(int j = 0; j < N; j ++){
            if(!A[i][j]) down1[i][j] = 0;
            else down1[i][j] = (i == N - 1 ? 0 : down1[i + 1][j]) + 1;
        }
    }

    int ans = 0;
    { /// check when no change
        vector<int> dp(N);
        for(int i = 0; i < N; i ++){
            for(int j = 0; j < N; j ++){
                dp[j] = (A[i][j] ? dp[j] + 1 : 0);
            }
            stack<pair<int, int>> st;
            for(int j = 0; j < N; j ++){
                int acc = 0;
                ans = max(ans, dp[j]);
                while(!st.empty() && st.top().fr >= dp[j]){
                    acc += st.top().sc;
                    ans = max(ans, acc * st.top().fr);
                    st.pop();
                }
                st.push({dp[j], acc + 1});
            }
            int acc = 0;
            while(!st.empty()){
                acc += st.top().sc;
                ans = max(ans, acc * st.top().fr);
                st.pop();
            }
        }
    }
    for(int i = 0; i < N; i ++){
        for(int j = 0; j < N; j ++){
            if(j == 0 && !A[i][j]){
                int l0 = 0, r0 = 0, ptr = 0;
                while(ptr < N && !A[i][ptr]){
                    ++ ptr;
                }
                r0 = ptr - 1;
                while(ptr < N &&  A[i][ptr]){
                    ++ ptr;
                }
                int min_up0 = 1e9, min_down0 = 1e9;
                for(int k = l0; k <= r0; k ++){
                    min_up0 = min(min_up0, up0[i][k]);
                    min_down0 = min(min_down0, down0[i][k]);
                }
                /**
                cout << "nuli: " << l0 << " " << r0 << endl;
                cout << "edin: " << r0 + 1 << " " << ptr - 1 << endl;
                cout << endl;
                */
                vector<int> my_up, my_down;
                for(int k = l0; k <= r0; k ++){
                    my_up.pb(min_up0);
                }
                for(int k = r0 + 1; k < ptr; k ++){
                    my_up.pb(up0[i][k]);
                }
                for(int k = l0; k <= r0; k ++){
                    my_down.pb(min_down0);
                }
                for(int k = r0 + 1; k < ptr; k ++){
                    my_down.pb(down0[i][k]);
                }
                ans = max(ans, check(my_down) + check(my_up) - (ptr - j));
            }
            if(A[i][j]){
                int l0 = 0, r0 = 0, ptr = j;
                while(ptr < N &&  A[i][ptr]){
                    ++ ptr;
                }
                l0 = ptr;
                while(ptr < N && !A[i][ptr]){
                    ++ ptr;
                }
                r0 = ptr - 1;
                while(ptr < N &&  A[i][ptr]){
                    ++ ptr;
                }
                int min_up0 = 1e9, min_down0 = 1e9;
                for(int k = l0; k <= r0; k ++){
                    min_up0 = min(min_up0, up0[i][k]);
                    min_down0 = min(min_down0, down0[i][k]);
                }
                /**
                cout << "edin: " << j << " " << r0 - 1 << endl;
                cout << "nuli: " << l0 << " " << r0 << endl;
                cout << "edin: " << r0 + 1 << " " << ptr - 1 << endl;
                cout << endl;
                */
                vector<int> my_up, my_down;
                for(int k = j; k < l0; k ++) my_up.pb(up1[i][k]);
                for(int k = l0; k <= r0; k ++) my_up.pb(min_up0);
                for(int k = r0 + 1; k < ptr; k ++) my_up.pb(up1[i][k]);
                for(int k = j; k < l0; k ++) my_down.pb(down1[i][k]);
                for(int k = l0; k <= r0; k ++) my_down.pb(min_down0);
                for(int k = r0 + 1; k < ptr; k ++) my_down.pb(down1[i][k]);
                /**
                for(auto x : my_down) cout << x << " "; cout << endl;
                for(auto x : my_up) cout << x << " "; cout << endl;
                de(check(my_down));
                de(check(my_up));
                */
                ans = max(ans, check(my_down) + check(my_up) - (ptr - j));
            }
        }
    }
    cout << ans << endl;
}
