#include "treeq.h"
#include<bits/stdc++.h>
using namespace std;
const int MAXN=2048;
vector<int>leaves;
int n;
bool leaf[MAXN];
set<int>ch[MAXN];
int par[MAXN];
vector<int>dfs_nodes;
bool found[MAXN];
int root=0;
void find_leaves()
{
    for(int i=1;i<=n;i++)
    {
        vector<int>v;
        for(int j=1;j<=n;j++)
        {
            if(j==i)v.push_back(j);
        }
        if(!query(v,i))
        {
            leaves.push_back(i);
            leaf[i]=1;
            found[i]=1;
        }
    }
}
void dfs(int u)
{
    dfs_nodes.push_back(u);
    for(auto xd:ch[u])
    {
        dfs(xd);
    }
}
void find_it(int u)
{
    dfs_nodes.clear();
    dfs(root);
    int low=1,high=dfs_nodes.size()-1,mid,ans;
    vector<int>v1;
    while(low<=high)
    {
        mid=(low+high)/2;
        v1.clear();
        for(int i=0;i<=mid;i++)
        {
            v1.push_back(dfs_nodes[i]);
        }
        if(query(v1,u)==false)
        {
            low=mid+1;
        }
        else
        {
            ans=mid;
            high=mid-1;
        }
    }
    int new_ch=dfs_nodes[ans];
    ch[par[new_ch]].erase(new_ch);
    par[u]=par[new_ch];
    ch[par[u]].insert(u);
    ch[u].insert(new_ch);
    par[new_ch]=u;
    //cout<<"$$ "<<u<<" "<<new_ch<<endl;
    vector<int>nodes1;
    for(int i=0;i<ans;i++)nodes1.push_back(dfs_nodes[i]);
    for(int j=ans+1;j<dfs_nodes.size();j++)
    {
        if(ch[par[u]].find(dfs_nodes[j])==ch[par[u]].end())break;
        nodes1.push_back(dfs_nodes[j]);
        if(query(nodes1,u)==true)
        {
            new_ch=dfs_nodes[j];
            ch[par[new_ch]].erase(new_ch);
            par[u]=par[new_ch];
            ch[par[u]].insert(u);
            ch[u].insert(new_ch);
            par[new_ch]=u;
        }
        nodes1.pop_back();
    }
}
void solve(int _n) {
    n=_n;
    find_leaves();
    //cout<<"leaves:\n";
    //for(auto xd:leaves)cout<<xd<<" ";
    //cout<<endl;
    for(int i=1;i<=n;i++)
    {
        if(leaf[i]==0)
        {
            root=i;break;
        }
    }
    found[root]=1;
    for(int i=1;i<=n;i++)
    {
        if(leaf[i])
        {
            ch[root].insert(i);
            par[i]=root;
        }
    }
    for(int i=1;i<=n;i++)
    {
        if(found[i]==0)find_it(i);
    }
    int cnt=0;
    for(int i=1;i<=n;i++)
    {
        cnt+=ch[i].size();
    }
    if(cnt!=n-1)assert(false);
    for(int i=1;i<=n;i++)
    {
        for(auto xd:ch[i])
        {
            //cout<<i<<" "<<xd<<endl;
            answer(i,xd);
        }
    }
}


/*
10
1 4
1 5
1 6
1 7
2 3
3 4
7 8
7 9
7 10
*/
