#include<bits/stdc++.h>
#include "treeq.h"
using namespace std;

const int MAXN=2005;

bool leaf[MAXN];
vector<int> leaves;
vector<int> path;
int curL;
bool found[MAXN];
int depth[MAXN];
vector<int> onDepth[MAXN];
bool mark[MAXN];
int maxd;
bool edge[MAXN][MAXN];

void add(int v)
{
    if(found[v])
    {
        if(depth[v]<depth[path[curL]]) return;
        for(int i=maxd+1;i<=depth[v];i++)
        {
            for(int j=0;j<onDepth[i].size();j++)
            {
                mark[onDepth[i][j]]=1;
            }
        }
        maxd=depth[v];
        path.insert(path.begin()+curL+1, v);
        curL++;
        return;
    }
    else
    {
        int l=curL, r=path.size()-1;
        while(l<r-1)
        {
            int mid=(l+r)/2; //
            if(query(vector<int> {path[l], path[mid]}, v)) r=mid;
            else l=mid;
        }
        path.insert(path.begin()+r, v);
    }
}

void solve(int n)
{
    for(int i=2;i<=n;i++)
    {
        vector<int> v;
        for(int j=1;j<=n;j++) if(j!=i) v.push_back(j);
        if(!query(v,i))
        {
            leaf[i]=1;
            leaves.push_back(i); //cout<<i<<endl;
        }
    }

    found[1]=1;
    depth[1]=1;
    for(int i=0;i<leaves.size();i++)
    {
        path.clear();
        path.push_back(1);
        path.push_back(leaves[i]);
        curL=0;
        memset(mark,0,sizeof(mark));
        maxd=1;
        for(int j=2;j<=n;j++)
        {
            if(leaf[j]) continue;
            if(mark[j]) continue;
            if(query(vector<int> {1,leaves[i]}, j)) add(j); // cout<<1<<" "<<leaves[i]<<" "<<j<<endl;
        }
        for(int j=curL+1;j<path.size();j++)
        {
            edge[path[j]][path[j-1]]=edge[path[j-1]][path[j]]=1;
            found[path[j]]=1;
            depth[path[j]]=depth[path[j-1]]+1;
            onDepth[depth[path[j]]].push_back(path[j]);
        }
    }
    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            if(edge[i][j]) answer(i,j); // cout<<i<<" "<<j<<endl;
        }
    }
}
