#include <bits/stdc++.h>
#define endl "\n"
#define pii pair<int, int>
#define ff first
#define ss second
using namespace std;

const int maxn = 2e3+3;

int matrix[maxn][maxn];
int rows[maxn][maxn], n;

int fxb, fxe, fyb, fye;
bool in_bounds(const int& x, const int& y)
{
    if(x < fxb || fxe < x || y < fyb || fye < y) return false;
    return true;
}
void print(int mtx[maxn][maxn]);
void print(int arr[maxn]);

void input()
{
    char c;
    cin >> n;
    for(int i = 1; i <= n; i++)
    for(int j = 1; j <= n; j++)
    {
        cin >> c;
        matrix[i][j] = (c == '1');
    }
}

void do_rows()
{
    for(int i = 1; i <= n; i++)
    for(int j = 1; j <= n; j++)
    {
        rows[i][j] = (rows[i][j-1] + 1) * matrix[i][j];
    }
}

int minleft[maxn], minright[maxn];
int do_column(int j)
{
    stack<pii> st;

    // left to right
    for(int i = 1; i <= n; i++)
    {
        while(!st.empty() && st.top().ff > rows[i][j])
            st.pop();
        if(st.empty()) minleft[i] = 0;
        else minleft[i] = st.top().ss;
        st.push({rows[i][j], i});
    }

    // right to left
    for(int i = n; i >= 1; i--)
    {
        while(!st.empty() && st.top().ff > rows[i][j])
            st.pop();
        if(st.empty()) minright[i] = n;
        else minright[i] = st.top().ss;
        st.push({rows[i][j], i});
    }

    print(minleft), print(minright); cout << endl;

    int result = 0;
    for(int i = 1; i <= n; i++)
        result = max(result, (minright[i] - minleft[i]) * rows[i][j]);
    return result;
 }

int do_columns()
{
    int result = 0;
    for(int j = 1; j <= n; j++)
        result = max(result, do_column(j));
    return result;
}

int calculate()
{
    do_rows();
    return do_columns();
}

int main()
{
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    // freopen("rectangle_input.txt", "r", stdin);
    input();
    cout << calculate() << endl;
    // print(matrix), print(rows);
    return 0;
}

void print(int mtx[maxn][maxn])
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            cout << mtx[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
}

void print(int arr[maxn])
{
    for(int j = 1; j <= n; j++)
    {
        cout << arr[j] << " ";
    }
    cout << endl;
}
