#include <iostream>
using namespace std;
const int MAXN=2e3+10;
int a[MAXN][MAXN], pref[MAXN][MAXN], maxr[MAXN][MAXN];
int n;
int find_sum(int i, int j, int k, int p) {
    return pref[k][p]-pref[k][j-1]-pref[i-1][p]+pref[i-1][j-1];
}
int find_maxs(int i, int j) {
    int curs=maxr[i][j];
    int ans=0;
    for (int k=1;k<=i;k++) {
        curs=min(curs,maxr[i-k+1][j]);
        ans=max(ans,curs*k);
    }
    return ans;
}
int find_max(int x1, int y1, int x2, int y2) {
    for (int i=x1;i<=x2;i++) {
        for (int j=y1;j<=y2;j++) a[i][j]=(a[i][j]+1)%2;
    }
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            if (a[i][j]==0) maxr[i][j]=0;
            else maxr[i][j]=maxr[i][j-1]+1;
        }
    }
    int ans=0;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            if (a[i][j]==0) continue;
            ans=max(ans,find_maxs(i,j));
        }
    }
    for (int i=x1;i<=x2;i++) {
        for (int j=y1;j<=y2;j++) a[i][j]=(a[i][j]+1)%2;
    }
    return ans;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    char ch;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            cin >> ch;
            a[i][j]=ch-'0';
            pref[i][j]=pref[i-1][j]+pref[i][j-1]-pref[i-1][j-1]+a[i][j];
        }
    }
    int ans=0;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            for (int k=i;k<=n;k++) {
                for (int p=j;p<=n;p++) {
                    //if (find_sum(i,j,k,p)!=0) continue;
                    //if (find_sum(i,j,k+1,p)==0 || find_sum(i,j,k,p+1)==0) continue;
                    ans=max(ans,find_max(i,j,k,p));
                }
            }
        }
    }
    cout << ans << endl;
    return 0;
}

