#include <bits/stdc++.h>
#include "treeq.h"

typedef long long ll;
typedef long double ld;

const ll Size=2e3+1,mod=1e9+7;
bool is_edge[Size][Size];
std::vector<int> ancesters[Size];

bool query(std::vector<int> S, int x);/*{
    bool t;
    for(ll i=0;i<S.size();i++){
        std::cout<<S[i]<<" ";
    }
    std::cout<<" "<<x<<":";
    std::cin>>t;
    return t;
}
*/
void answer(int u,int v);/*{
    std::cout<<u<<" "<<v<<std::endl;
}
*/
void solve(int n){
    std::vector<int> to_check;
    to_check.push_back(1);
    for(ll i=2;i<=n;i++){
        ancesters[i].push_back(1);
        to_check.push_back(i);
        bool edge=true;
        for(ll j=i+1;j<=n;j++){
            if(j!=i){
                to_check.push_back(j);
                // on a path
                bool res=query(to_check,1);
                if(res){
                    to_check.pop_back();
                    // j on path 1-i
                    res=query(to_check,j);
                    if(res){
                        ancesters[i].push_back(j);
                    }else{
                        to_check.pop_back();
                        to_check.push_back(j);
                        // i on path 1-j
                        res=query(to_check,i);
                        if(res){
                            ancesters[j].push_back(i);
                        }
                        to_check.pop_back();
                        to_check.push_back(i);
                    }
                }else{
                    to_check.pop_back();
                }
            }
        }
        to_check.pop_back();
    }
    for(ll i=1;i<=n;i++){
        for(auto itrv:ancesters[i]){
            if(std::max(ancesters[i].size(),ancesters[itrv].size())-std::min(ancesters[i].size(),ancesters[itrv].size())==1){
                is_edge[i][itrv]=1;
            }
        }
    }
    for(ll i=1;i<=n;i++){
        for(ll j=i+1;j<=n;j++){
            if(is_edge[i][j]){
                answer(i,j];)
            }
        }
    }
}
/*
int main(){
    solve(5);
    return 0;
}
*/
