#include <iostream>
#include <vector>
#include<cstring>
using namespace std;

int broiChisla;

int broiBitove;

int iskano[3010];

int chisla[3010][3010];

int naiLqvSetnatBit[3010];

long long stepeniDvoika[3010];

long long iskChi;
long long desChisla[3010];

long long otg;

void broiVazmojnosti(int index, long long resDoTuk) {
    if (index == broiChisla) {
        if (resDoTuk == iskChi) {
            otg++;
        }
        return ;
    }

    for (int i = 0; i <= desChisla[index]; i++) {
        broiVazmojnosti(index + 1, resDoTuk ^ i);
    }
}

int main()
{

    cin >> broiChisla >> broiBitove;
    
    string vhodIskano;
    cin >> vhodIskano;

    for (int i = 0; i < broiBitove; i++) {
        iskano[i] = vhodIskano[i] - '0';
    }

    for (int i = 0; i < broiChisla; i++) {
        string chiTuka;
        cin >> chiTuka;
        for (int j = 0; j < broiBitove; j++) {
            chisla[i][j] = chiTuka[j] - '0';
        }
    }
    
    for (int i = 0; i < broiChisla; i++) {
        for (int j = 0; j < broiBitove; j++) {
            if (chisla[i][j] == 1) {
                naiLqvSetnatBit[i] = j;
                break;
            }
        }
    }

    stepeniDvoika[broiBitove - 1] = 1;
    for (int i = broiBitove - 2; i >= 0; i--) {
        stepeniDvoika[i] = 2 * stepeniDvoika[i + 1];
    }
    
    iskChi = 0;

    for (int i = 0; i < broiBitove; i++) {
        iskChi += stepeniDvoika[i] * iskano[i];
    }

    for (int i = 0; i < broiChisla; i++) {
        for (int j = 0; j < broiBitove; j++) {
            desChisla[i] += stepeniDvoika[j] * chisla[i][j];
        }
    }

    for (int i = 0; i <= desChisla[0]; i++) {
        broiVazmojnosti(1, i);
    }

    cout << otg << endl;


}
