#include<bits/stdc++.h>
#define MAXN 2007
using namespace std;

int n,res;
char t[MAXN][MAXN];
int s[MAXN],pr[MAXN],nxt[MAXN];
stack<int> st;

int solve(){
    s[0]=s[n+1]=-1;
    int ans=0;
    for(int i=1;i<=n;i++)s[i]=0;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            if(t[i][f]=='1')s[f]++;
            else s[f]=0;
        }
        for(int f=0;f<=n+1;f++){
            while(!st.empty() and s[f]<=s[st.top()])st.pop();
            if(!st.empty())pr[f]=st.top();
            st.push(f);
        }
        for(int f=n+1;f>=0;f--){
            while(!st.empty() and s[f]<=s[st.top()])st.pop();
            if(!st.empty())nxt[f]=st.top();
            st.push(f);
        }

        for(int f=1;f<=n;f++){
            ans=max(ans,(nxt[f]-pr[f]-1)*s[f]);
        }
    }
    return ans;
}

void flip(int r1,int r2,int c1,int c2){
    for(int i=r1;i<=r2;i++){
        for(int f=c1;f<=c2;f++){
            if(t[i][f]=='0')t[i][f]='1';
            else t[i][f]='0';
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            cin>>t[i][f];
        }
    }

    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            for(int k=f;k<=n;k++){
                flip(1,i,f,k);
                res=max(res,solve());
                flip(1,i,f,k);
            }
        }
    }

    cout<<res<<"\n";

    return 0;
}
