#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx512")
using namespace std;
#define endl "\n"
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 3e3 + 10;
string inp[MAX_N];
int n;

vector<int> changes[MAX_N];
ll value[MAX_N];
ll pref[MAX_N], suf[MAX_N];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif

    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> inp[i];
    }

    ll ans = 0;
    for(int l = 0; l < n; l ++) {
        for(int i = 0; i < n; i ++) {
            changes[i].resize(0);
            value[i] = 0;
        }

        for(int r = l; r < n; r ++) {
            cerr << "Solving for " << l << " " << r << endl;
            for(int i = 0; i < n; i ++) {
                if(l != r && inp[i][r] != inp[i][r - 1]) {
                    changes[i].push_back(r);
                    value[i] = (value[i] * mod + (r + 1));
                } else if(l == r && inp[i][r] == '0') {
                    changes[i].push_back(r);
                    value[i] = (value[i] * mod + (r + 1));
                }
            }
            for(int i = 0; i < n; i ++) {
                cerr << i << " " << value[i] << ": ";
                for(const auto x : changes[i]) {
                    cerr << x << " ";
                }
                cerr << endl;
            }

            {
                int curr = 0;
                for(int i = 0; i < n; i ++) {
                    if(changes[i].empty()) {
                        curr ++;
                        chkmax(ans, curr * (r - l + 1));
                    } else {
                        curr = 0;
                    }
                    pref[i] = curr;
                }
            }

            {
                int curr = 0;
                for(int i = n - 1; i >= 0; i --) {
                    if(changes[i].empty()) {
                        curr ++;
                    } else {
                        curr = 0;
                    }
                    suf[i] = curr;
                }
            }

            int currValue = -1;
            int currSum = 0;
            for(int i = 0; i < n; i ++) {
                if(changes[i].size() > 2) {
                    currValue = -1;
                    currSum = 0;
                    continue;
                }
                if(currValue == value[i]) {
                    currSum += 1;
                } else {
                    currValue = value[i];
                    currSum = (i == 0) ? 1 : 1 + pref[i - 1];
                }
                int poss = (i == n - 1) ? currSum : currSum + suf[i + 1];
                chkmax(ans, poss * (r - l + 1));
            }
            cerr << "After solve " << l << " " << r << " " << ans << endl;
        }
    }

    cout << ans << endl;

    return 0;
}

/*
3
010
100
100