#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
using namespace std;
#define endl "\n"
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 3e3 + 10;
string inp[MAX_N];
int n;

ll cnt[MAX_N];
ll value[MAX_N];
ll pref[MAX_N], suf[MAX_N];

ll solve_fast() {
    ll ans = 0;
    for(int l = 0; l < n; l ++) {
        for(int i = 0; i < n; i ++) {
            cnt[i] = 0;
            value[i] = 0;
        }

        for(int r = l; r < n; r ++) {
            for(int i = 0; i < n; i ++) {
                if(l != r && inp[i][r] != inp[i][r - 1]) {
                    cnt[i] ++;
                    value[i] = (value[i] * mod + (r + 1));
                } else if(l == r && inp[i][r] == '0') {
                    cnt[i] ++;
                    value[i] = (value[i] * mod + (r + 1));
                }
            }

            {
                int curr = 0;
                for(int i = 0; i < n; i ++) {
                    if(cnt[i] == 0) {
                        curr ++;
                        chkmax(ans, curr * (r - l + 1));
                    } else {
                        curr = 0;
                    }
                    pref[i] = curr;
                }
            }

            {
                int curr = 0;
                for(int i = n - 1; i >= 0; i --) {
                    if(cnt[i] == 0) {
                        curr ++;
                    } else {
                        curr = 0;
                    }
                    suf[i] = curr;
                }
            }

            ll currValue = -1;
            int currSum = 0;
            for(int i = 0; i < n; i ++) {
                if(cnt[i] > 2) {
                    currValue = -1;
                    currSum = 0;
                    continue;
                }
                if(currValue == value[i]) {
                    currSum ++;
                } else {
                    currValue = value[i];
                    currSum = (i == 0) ? 1 : 1 + pref[i - 1];
                }
                int poss = (i == n - 1) ? currSum : currSum + suf[i + 1];
                chkmax(ans, poss * (r - l + 1));
            }
        }
    }

    return ans;
}

void flip(int lx, int ly, int rx, int ry) {
    for(int i = lx; i <= rx; i ++) {
        for(int j = ly; j <= ry; j ++) {
            inp[i][j] = (inp[i][j] == '1') ? '0' : '1';
        }
    }
}

bool ok(int lx, int ly, int rx, int ry) {
    for(int i = lx; i <= rx; i ++) {
        for(int j = ly; j <= ry; j ++) {
            if(inp[i][j] == '0') {
                return false;
            }
        }
    }
    return true;
}

int find_biggest() {
    int ans = 0;
    for(int lx = 0; lx < n; lx ++) {
        for(int rx = lx; rx < n; rx ++) {
            for(int ly = 0; ly < n; ly ++) {
                for(int ry = 0; ry < n; ry ++) {
                    if(ok(lx, ly, rx, ry)) {
                        chkmax(ans, (rx - lx + 1) * (ry - ly + 1));
                    }
                }
            }
        }
    }
    return ans;
}

int solve_slow() {
    int ans = find_biggest();
    for(int lx = 0; lx < n; lx ++) {
        for(int rx = lx; rx < n; rx ++) {
            for(int ly = 0; ly < n; ly ++) {
                for(int ry = 0; ry < n; ry ++) {
                    flip(lx, ly, rx, ry);
                    chkmax(ans, find_biggest());
                    flip(lx, ly, rx, ry);
                }
            }
        }
    }
    return ans;
}

void generate_random() {
    for(int i = 0; i < n; i ++) {
        inp[i].resize(n);
        for(int j = 0; j < n; j ++) {
            inp[i][j] = '0' + (rand() % 2);
        }
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif

    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> inp[i];
    }

    ll ans = solve_fast();
    cout << ans << endl;

    return 0;

    while(true) {
        generate_random();
        if(solve_slow() != solve_fast()) {
            cout << solve_slow() << endl;
            cout << solve_fast() << endl;
            cout << n << endl;
            for(int i = 0; i < n; i ++) {
                cout << inp[i] << endl;
            }
            break;
        }
    }

    return 0;
}

/*
6
111011
011011
101001
111110
010000
000001
*/
