/**
    Зам деле думля да
    зам деле думля да
    зам деле деле деле
    думля да да да да
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <cstring>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 3000 + 10;
const int MOD  = 998244354;
const int INF  = 1e9;

int n, b, k;
char k2[MAXN];
char a2[MAXN][MAXN];
int mask[MAXN];
int pow[MAXN];

int brute(int pos, int curr)
{
    if (pos == n + 1)
    {
        return curr == k;
    }

    int ans = 0;
    for (int i = 0 ; i <= mask[pos] ; ++i)
    {
        ans += brute(pos + 1, curr ^ i);
    }

    return ans;
}

void solve()
{
    pow[0] = 1;
    for (int i = 1 ; i <= b ; ++i)
    {
        pow[i] = pow[i - 1] * 2;
        if (pow[i] > MOD) pow[i] -= MOD;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 0 ; j < b ; ++j)
        {
            mask[i] += (a2[i][j] == '1') * pow[b - j - 1];
        }
    }

    for (int j = 0 ; j < b ; ++j)
    {
        k += (k2[j] == '1') * pow[b - j - 1];
    }

    std::cout << brute(1, 0) << '\n';
}

void input()
{
    std::cin >> n >> b;
    std::cin >> k2;

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a2[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}

