#include <iostream>
#define MAX_N 300
using namespace std;


const long long mod = 998244354;
long long table[2][MAX_N];
string enter;
long long u[MAX_N];
long long n, b, k;

long long translate()
{
    long long num=0;
    long long mul=1;
    for(int i=enter.size()-1; i>=0; i--)
    {
        num+=(enter[i]-'0')*mul;
        mul*=2;
    }
    return num;
}

void fill_table(int index)
{
    int ind=index%2;
    int pind=(index+1)%2;
    long long fel;
    fill_n(table[ind], MAX_N, 0);
    for(int i=0; i<=u[index]; i++)
    {
        for(int j=0; j<=u[index-1]; j++)
        {
            fel=(j^i);
            table[ind][fel]=(table[ind][fel]+table[pind][j])%mod;
        }
    }
}

int main()
{
    cin >> n >> b;

    cin >> enter;
    k=translate();

    for(int i=1; i<=n; i++)
    {
        cin >> enter;
        u[i]=translate();
    }

    for(int i=0; i<=u[1]; i++)
    {
        table[1][i]=1;
    }

    for(int i=2; i<=n; i++)
    {
        fill_table(i);
        /*for(int j=0; j<20; j++)
        {
            cout << table[i%2][j] << ", ";
        }
        cout << endl;*/
    }

    cout << table[n%2][k];








    return 0;
}
