#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e8, smalln = 21;
const int mod = 998244354, maxbit = 61;

int n, b;
vector < vector < int > > u;
vector < int > k;
int dp[maxbit][(1 << smalln)], used[maxbit][(1 << smalln)];
int solve_state(int bit, int mask)
{
    ///cout << bit << " : " << mask << endl;
    if (bit == b)
        return 1;
    if (used[bit][mask])
        return dp[bit][mask];

    used[bit][mask] = 1;
    int ways = 0, id = -1;
    bool done = false;
    for (int i = 0; i < n; i ++)
        if ((mask & (1 << i)) != 0)
            done = true, id = i;
    if (!done)
    {
        for (int state = 0; state < (1 << n); state ++)
        {
            bool is_valid = true;
            int new_mask = mask, xor_sum = 0;
            for (int i = 0; i < n; i ++)
                if ((state & (1 << i)) > 0)
                    xor_sum ++;
            xor_sum %= 2;
            if (xor_sum != k[bit])
                continue;

            for (int i = 0; i < n; i ++)
            {
                if ((state & (1 << i)) == 0)
                {
                    if (u[i][bit] == 1 && (mask & (1 << i)) == 0)
                        new_mask |= (1 << i);
                }
                else
                {
                    if (u[i][bit] == 0 && (mask & (1 << i)) == 0)
                        is_valid = false;
                }
            }

            if (!is_valid)
                continue;
            ///cout << "here " << bit << " " << mask << " " << state << " " << new_mask << endl;
            ways = (ways + solve_state(bit + 1, new_mask));
            if (ways >= mod)
                ways -= mod;
        }
        dp[bit][mask] = ways;
    }
    else
    {
        ll ans = 1;
        for (int i = 0; i < n; i ++)
        {
            if (i == id)
                continue;
            if ((mask & (1 << i)) == 1)
                ans = (ans * (ll)((ll)(1) << (b - bit))) % mod;
            else
                ans = (ans * (ll)((ll)(1) << (b - bit - 1))) % mod;
        }
        dp[bit][mask] = ans;

    }
    //cout << bit << " : " << mask << " : " << dp[bit][mask] << endl;

    return dp[bit][mask];
}
void solve()
{
    cin >> n >> b;
    k.resize(b);
    for (int i = 0; i < b; i ++)
    {
        char c;
        cin >> c;
        k[i] = c - '0';
    }
    u.resize(n);
    for (int i = 0; i < n; i ++)
    {
        u[i].resize(b);
        for (int j = 0; j < b; j ++)
        {
            char c;
            cin >> c;
            u[i][j] = c - '0';
        }
    }

    cout << solve_state(0, 0) << endl;
}

int main()
{
    solve();
    return 0;
}
/**
2 : 3 : 2
1 : 3 : 4
2 : 1 : 1
1 : 0 : 1
0 : 0 : 5
*/
