#include<bits/stdc++.h>
using namespace std;
const int maxn = 2048;
int n;
int a[maxn*maxn], newa[maxn*maxn], prec[maxn][maxn];
int ansarea;

void read(){
    cin >> n;
    string s;
    for (int i = 1; i <= n; ++i){
        cin >> s;
        for (int j = 0; j < n; ++j)
            a[(i - 1) * n + j + 1] = s[j] - '0';
    }
}

void check_area(int *mat){
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j){
            if (mat[(i - 1) * n + j] == 1)
                prec[i][j] = prec[i - 1][j] + 1;
            else prec[i][j] = 0;
        }
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j){
            int k = j;
            int curarea = 0;
            int minwid = (1<<30);
            while (mat[(i - 1) * n + k] == 1 && k > 0){
                minwid = min(minwid,  prec[i][k]);
                curarea = minwid * (j - k + 1);
                ansarea = max(curarea, ansarea);
                --k;
            }
        }
}

void changematrix(int x, int y, int len, int wid){
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            newa[(i - 1) * n + j] = a[(i - 1) * n + j];
    for (int i = x; i <= x + len - 1; i++)
        for (int j = y; j <= y + wid - 1; ++j)
            newa[(i - 1) * n + j] ^= 1;
}

void solve(){
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            for (int len = 1; len + i - 1 <= n; ++len)
                for (int wid = 1; wid + j - 1 <= n; ++len){
                    changematrix(i, j, len, wid);
                    check_area(newa);
                }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    cout << "read done\n";
    check_area(a);
    cout << "checked first area\n";
    solve();
    cout << ansarea << endl;
    return 0;
}
