#include<bits/stdc++.h>
using namespace std;
const int maxn = 2048;
int n;
int a[maxn][maxn];
int l[maxn][maxn];

void read()
{
    cin >> n;
    for( int i = 1; i <= n; i ++ )
    {
        string s;
        cin >> s;

        for( int j = 0; j < n; j ++ )
        {
            a[i][j+1] = ( s[j] - '0' );
        }
    }

    for( int i = 1; i <= n; i ++ )
    {
        int x = 0;
        for( int j = 1; j <= n; j ++ )
        {
            l[i][j] = x;
            if( a[i][j] == 0 ) x = j;
            //cout << l[i][j] << " ";
        }
        //cout << endl;
    }
}

int get_area( int i, int j, int w, int h )
{
    int area = 0;
    for( int ii = i; ii <= i + w - 1; ii ++ )
    {
        for( int jj = j; jj <= j + h - 1; jj ++ )
        {
            area += a[ii][jj];
        }
    }
    return area;
}

int check( int i, int j, int w, int h, int raz )
{
    for( int p = i; p <= i + w - 1; p ++ )
    {
        for( int q = j; q <= j + h - 1; q ++ )
        {
            if( a[p][q] == 1 ) continue;

            int tl = l[p][q];
            int tr = p;


            for( int k = p+1; k <= p; k ++ )
            {
                if( a[k][q] == 1 ) break;
                tl = max( tl , l[k][q] );
                tr = k;
            }

            int x = abs( tl - q + 1 ) * abs( tr - p + 1);

            if( x == raz ) return 1;

        }
    }

    return 0;
}
void solve()
{
    int ans = 0;
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= n; j ++ )
        {

            for( int w = 1; w <= n; w ++ )
            {
                if( i + w - 1 > n ) break;

                for( int h = 1; h <= n; h ++ )
                {
                    if( j + h - 1 > n ) break;

                    int area = get_area(i,j,w,h);

                    //cout << i << " " << j << " " << w << " " << h << " - > " << area << endl;

                    if( area == w * h )
                    {

                        ans = max( ans , area );
                        continue;
                    }

                    int y = check(i,j,w,h,w*h-area);
                    if( y == 1 )
                    {
                        //cout << i << " " << j << " " << w << " " << h << " - >>>>>>>>>>>  " << area << endl;
                        ans = max( ans , w * h );
                        continue;
                    }
                }
            }
        }
    }
    cout << ans << endl;
}
int main()
{
    read();
    solve();
    return 0;
}
