#include<bits/stdc++.h>
#include "treeq.h"

//bool query(std::vector<int> S, int x)
//void answer(int u, int v)

std::vector<int> S, v;
int ban[2001][2001], cnt, used[2001];

void recursion(int l, int r, int n)
{
    if(cnt == n-1) return;
    if(ban[l][r] || ban[r][l]) return;
    ban[l][r] = 1;
    ban[r][l] = 1;
    used[l] = 1;
    used[r] = 1;
    S[0] = l;
    S[1] = r;
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            v.push_back(i);
            if(query(S, i) == true)
            {
                for(int j=0;j<v.size();j++)
                {
                    used[v[j]] = 1;
                }
                recursion(l, i, n);
                recursion(i, r, n);
                for(int j=0;j<v.size();j++)
                {
                    used[v[j]] = 0;
                }
                v.clear();
                return;
            }
        }
    }
    answer(l, r);
    cnt++;
    for(int j=0;j<v.size();j++)
    {
        used[v[j]] = 0;
    }
    v.clear();
    return;
}

void solve(int n)
{
    S.push_back(0);
    S.push_back(0);
    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            if(!ban[i][j] && !ban[j][i])
            {
                memset(used, 0, sizeof(used));
                recursion(i, j, n);
                if(cnt == n-1) return;
            }
        }
    }
}
