#include<bits/stdc++.h>
#include "treeq.h"
using namespace std;

const int MAXN=2005;

bool leaf[MAXN];
vector<int> leaves;
vector<int> path;
bool edge[MAXN][MAXN];

void add(int v)
{
    int l=0, r=path.size()-1;
    while(l<r-1)
    {
        int mid=(l+r)/2; //
        if(query(vector<int> {path[l], path[mid]}, v)) r=mid;
        else l=mid;
    }
    path.insert(path.begin()+r, v);
}

void solve(int n)
{
    for(int i=2;i<=n;i++)
    {
        vector<int> v;
        for(int j=1;j<=n;j++) if(j!=i) v.push_back(j);
        if(!query(v,i))
        {
            leaf[i]=1;
            leaves.push_back(i); //cout<<i<<endl;
        }
    }
    for(int i=0;i<leaves.size();i++)
    {
        path.clear();
        path.push_back(1);
        path.push_back(leaves[i]);
        for(int j=2;j<=n;j++)
        {
            if(leaf[j]) continue;
            if(query(vector<int> {1,leaves[i]}, j)) add(j); // cout<<1<<" "<<leaves[i]<<" "<<j<<endl;
        }
        for(int j=1;j<path.size();j++)
        {
            edge[path[j]][path[j-1]]=edge[path[j-1]][path[j]]=1;
        }
    }
    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            if(edge[i][j]) answer(i,j); // cout<<i<<" "<<j<<endl;
        }
    }
}
