#include "treeq.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

int n;
bool used[3000];
bool in[3000][3000];

mt19937 rg(4093542);

void answer(int u, int v);

bool query(vector<int> S, int x);

void DFS(int u, int p)
{
    used[u] = true;
    vector<int> active;
    for (int w = 1; w <= n; ++ w)
    {
        if (used[w]) continue;
        if (in[u][w]) active.push_back(w);
        else if (p == -1 or !query({u, w}, p)) active.push_back(w);
    }
    while (true)
    {
        vector<int> tmp;
        for (auto w : active)
        {
            if (!used[w]) tmp.push_back(w);
        }
        active = tmp;
        if (active.size() == 0) break;
        int idx = rg() % active.size();
        int v = active[idx];
        tmp.clear();
        for (int i = 0; i < active.size(); ++ i)
        {
            if (i == idx) continue;
            int w = active[i];
            if (query({u, v}, w))
            {
                v = w;
                tmp.push_back(w);
            }
        }
        answer(u, v);
        for (auto w : tmp)
        {
            in[v][w] = true;
        }
        DFS(v, u);
    }
}

void solve(int n_)
{
    n = n_;
    DFS(rg() % n + 1, -1);
}
