#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 3000;
const int MOD = 998244354;

int n, b;
string s[MAXN + 5], sk;
bool valid[2][15000000];
long long dp[2][15000000];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> b;

    cin >> sk;

    for (int i = 0; i < n; ++ i)
    {
        cin >> s[i];
    }

    long long maskn = 1;
    for (int i = 1; i <= n; ++ i)
    {
        maskn *= 2;
    }

    for (int mask = 0; mask < maskn; ++ mask)
    {
        int cnt = 0;
        bool flag = true;
        int t = mask;
        for (int j = 0; j < n; ++ j, t /= 2)
        {
            if (t % 2 == 1 and s[j][0] == '0') flag = false;
            if (t % 2 == 0 and s[j][0] == '1') cnt++;
        }

        if (!flag) continue;

        if (cnt % 2 == (sk[0] - '0'))
        {
            dp[0][mask] = 1;
            valid[0][mask] = true;
        }
    }

    int curr = 0;
    for (int i = 1; i < b; ++ i)
    {
        curr ^= 1;
        for (int mask = 0; mask < maskn; ++ mask)
        {
            dp[curr][mask] = 0;
            valid[curr][mask] = false;
        }
        for (int mask1 = 0; mask1 < maskn; ++ mask1)
        {
            if (!valid[curr ^ 1][mask1]) continue;
            for (int mask2 = 0; mask2 < maskn; ++ mask2)
            {
                int cnt = 0;
                bool flag = true;
                int t1 = mask1, t2 = mask2;
                for (int j = 0; j < n; ++ j, t1 /= 2, t2 /= 2)
                {
                    if (t1 % 2 and t2 % 2 == 0) flag = false;
                    if (t1 % 2 == 0 and (t2 % 2 == 1 and s[j][i] == '0')) flag = false;
                    if (t2 % 2 == 0 and s[j][i] == '1') cnt++;
                }

                if (!flag) continue;

                for (int mask3 = 0; mask3 < maskn; ++ mask3)
                {
                    int t3 = mask3;
                    t2 = mask2;
                    t1 = mask1;
                    bool flag2 = true;
                    int cnt2 = cnt;
                    for (int j = 0; j < n; ++ j, t3 /= 2, t2 /= 2, t1 /= 2)
                    {
                        if (t2 % 2 == 0 and t3 % 2 == 1) flag2 = false;
                        if (t1 % 2 == 0 and t3 % 2 == 1) flag2 = false;
                        if (t1 % 2 == 1 and t3 % 2 == 1) cnt2++;
                    }

                    if (!flag2) continue;

                    if (cnt2 % 2 == (sk[i] - '0'))
                    {
                        dp[curr][mask2] += dp[curr ^ 1][mask1];
                        dp[curr][mask2] %= MOD;
                        valid[curr][mask2] = true;
                    }
                }
            }
        }
    }

    long long ans = 0;
    for (int mask = 0; mask < maskn; ++ mask)
    {
        ans += dp[curr][mask];
        ///cout << mask << " " << dp[curr][mask] << endl;
        ans %= MOD;
    }
    cout << ans << endl;

    return 0;
}
