#include <iostream>
#include <string>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int n;
int tab[MAXN + 5][MAXN + 5];
int dep[MAXN + 5][MAXN + 5];
int pref[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        string s;
        cin >> s;

        for (int j = 1; j <= n; ++ j)
        {
            tab[i][j] = (s[j - 1] - '0');
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + tab[i][j];
        }
    }

    int ans = 0;
    for (int i = n; i >= 1; -- i)
    {
        for (int j = n; j >= 1; -- j)
        {
            if (tab[i][j] == 0) continue;
            dep[i][j] = dep[i + 1][j] + 1;

            int mn = n + 1, mn2 = n + 1, l = 0, r = 0;
            for (int k = j; k <= n; ++ k)
            {
                if (dep[i][k] == 0 and r == -1) break;
                if (mn == dep[i][k])
                {
                    if (r == k - 1) r++;
                    else r = -1;
                }
                if (mn > dep[i][k])
                {
                    mn2 = mn;
                    mn = dep[i][k];
                    l = r = k;
                }
                /// cout << i << " " << j << " " << mn << " " << mn2 << " " << l << " " << r << endl;
                if (r == -1) ans = max(ans, mn * (k - j + 1));
                else
                {
                    int le = mn, ri = mn2 + 1, mid;
                    while (ri - le > 1)
                    {
                        mid = (le + ri) / 2;
                        /// iskame da proverim za pravougulnika s goren lqv krai (i + mn, l) i dolen desen krai (i + mid - 1, r)
                        int t = pref[i + mid - 1][r] - pref[i + mn - 1][r] - pref[i + mid - 1][l - 1] + pref[i + mn - 1][l - 1];
                        if (t == 0) le = mid;
                        else ri = mid;
                    }
                    ans = max(ans, le * (k - j + 1));
                }
            }
        }
    }
    cout << ans << endl;

    return 0;
}
/**
5
11111
11110
11101
11011
10111
*/
