#include <iostream>
#include <string>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int n;
int tab[MAXN + 5][MAXN + 5];
int dep[MAXN + 5][MAXN + 5];
int len[MAXN + 5][MAXN + 5];
int pref[MAXN + 5][MAXN + 5];

void invert(int i, int j, int i2, int j2)
{
    for (int i0 = i; i0 <= i2; ++ i0)
    {
        for (int j0 = j; j0 <= j2; ++ j0)
        {
            tab[i0][j0] ^= 1;
        }
    }
}

int calc()
{
    int ret = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            for (int i2 = i; i2 <= n; ++ i2)
            {
                for (int j2 = j; j2 <= n; ++ j2)
                {
                    if (pref[i2][j2] - pref[i - 1][j2] - pref[i2][j - 1] + pref[i - 1][j - 1] == (i2 - i + 1) * (j2 - j + 1)) ret = max(ret, (i2 - i + 1) * (j2 - j + 1));
                }
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        string s;
        cin >> s;

        for (int j = 1; j <= n; ++ j)
        {
            tab[i][j] = (s[j - 1] - '0');
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + tab[i][j];
        }
    }

    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            for (int i2 = i; i2 <= n; ++ i2)
            {
                for (int j2 = j; j2 <= n; ++ j2)
                {
                    invert(i, j, i2, j2);
                    ans = max(ans, calc());
                    invert(i, j, i2, j2);
                }
            }
        }
    }
    cout << ans << endl;

    return 0;
}
/**
5
11111
11110
11101
11011
10111
*/
