#include <iostream>
#include <string>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int n;
int dep[MAXN + 5][MAXN + 5];
int len[MAXN + 5][MAXN + 5];
int pref[MAXN + 5][MAXN + 5];
int tab[MAXN + 5][MAXN + 5], tab2[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        string s;
        cin >> s;

        for (int j = 1; j <= n; ++ j)
        {
            tab[i][j] = (s[j - 1] - '0');
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + tab[i][j];
        }
    }

    int ans = 0;
    for (int i = n; i >= 1; -- i)
    {
        for (int j = n; j >= 1; -- j)
        {
            if (tab[i][j] == 0)
            {
                dep[i][j] = len[i][j] = 0;
            }
            else
            {
                dep[i][j] = dep[i + 1][j] + 1;
                len[i][j] = len[i][j + 1] + 1;
            }

            int mn = n - i + 1, mn2 = n - i + 1, l = 0, r = 0;
            for (int k = j; k <= n; ++ k)
            {
                if (dep[i][k] == 0 and r == -1) break;
                if (mn == dep[i][k])
                {
                    if (r == k - 1) r++;
                    else r = -1;
                }
                else if (mn > dep[i][k])
                {
                    mn2 = mn;
                    mn = dep[i][k];
                    l = r = k;
                }
                else if (mn2 > dep[i][k]) mn2 = dep[i][k];
                /// cout << i << " " << j << " " << mn << " " << mn2 << " " << l << " " << r << endl;
                if (r == -1) ans = max(ans, mn * (k - j + 1));
                else
                {
                    /**int le = mn - 1, ri = mn2, mid;
                    while (ri - le > 1)
                    {
                        mid = (le + ri) / 2;
                        /// iskame da proverim za pravougulnika s goren lqv krai (i + mn, l) i dolen desen krai (i + mid - 1, r)
                        int t = pref[i + mid - 1][r] - pref[i + mn - 1][r] - pref[i + mid - 1][l - 1] + pref[i + mn - 1][l - 1];
                        if (t == 0) le = mid;
                        else ri = mid;
                    }
                    ans = max(ans, (le + 1) * (k - j + 1));*/
                    int t = mn;
                    while (i + t <= n and t < mn2 and pref[i + t][r] - pref[i + t][l - 1] - pref[i + t - 1][r] + pref[i + t - 1][l - 1] == 0) t++;
                    ans = max(ans, t * (k - j + 1));
                }
            }

            mn = mn2 = n - j + 1;
            l = r = 0;
            for (int k = i; k <= n; ++ k)
            {
                if (len[k][j] == 0 and r == -1) break;
                if (mn == len[k][j])
                {
                    if (r == k - 1) r++;
                    else r = -1;
                }
                else if (mn > len[k][j])
                {
                    mn2 = mn;
                    mn = len[k][j];
                    l = r = k;
                }
                else if (mn2 > len[k][j]) mn2 = len[k][j];
                /// cout << i << " " << j << " " << mn << " " << mn2 << " " << l << " " << r << endl;
                if (r == -1) ans = max(ans, mn * (k - i + 1));
                else
                {
                    /**int le = mn - 1, ri = mn2, mid;
                    while (ri - le > 1)
                    {
                        mid = (le + ri) / 2;
                        /// iskame da proverim za pravougulnika s goren lqv krai (l, j + mn) i dolen desen krai (r, j + mid - 1)
                        int t = pref[r][j + mid - 1] - pref[r][j + mn - 1] - pref[l - 1][j + mid - 1] + pref[l - 1][j + mn - 1];
                        if (t == 0) le = mid;
                        else ri = mid;
                    }
                    ans = max(ans, (le + 1) * (k - i + 1));*/
                    int t = mn;
                    while (j + t <= n and t < mn2 and pref[r][j + t] - pref[l - 1][j + t] - pref[r][j + t - 1] + pref[l - 1][j + t - 1] == 0) t++;
                    ///cout << i << " " << j << " " << k << " " << t << endl;
                    ans = max(ans, t * (k - i + 1));
                    ///cout << ans << endl;
                }
            }
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            tab2[i][j] = tab[i][j];
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            tab[i][j] = tab2[n + 1 - i][n + 1 - j];
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + tab[i][j];
            ///cout << tab[i][j];
        }
        ///cout << endl;
    }

    for (int i = n; i >= 1; -- i)
    {
        for (int j = n; j >= 1; -- j)
        {
            if (tab[i][j] == 0)
            {
                dep[i][j] = len[i][j] = 0;
            }
            else
            {
                dep[i][j] = dep[i + 1][j] + 1;
                len[i][j] = len[i][j + 1] + 1;
            }

            int mn = n - i + 1, mn2 = n - i + 1, l = 0, r = 0;
            for (int k = j; k <= n; ++ k)
            {
                if (dep[i][k] == 0 and r == -1) break;
                if (mn == dep[i][k])
                {
                    if (r == k - 1) r++;
                    else r = -1;
                }
                else if (mn > dep[i][k])
                {
                    mn2 = mn;
                    mn = dep[i][k];
                    l = r = k;
                }
                else if (mn2 > dep[i][k]) mn2 = dep[i][k];
                /// cout << i << " " << j << " " << mn << " " << mn2 << " " << l << " " << r << endl;
                if (r == -1) ans = max(ans, mn * (k - j + 1));
                else
                {
                    /**int le = mn - 1, ri = mn2, mid;
                    while (ri - le > 1)
                    {
                        mid = (le + ri) / 2;
                        /// iskame da proverim za pravougulnika s goren lqv krai (i + mn, l) i dolen desen krai (i + mid - 1, r)
                        int t = pref[i + mid - 1][r] - pref[i + mn - 1][r] - pref[i + mid - 1][l - 1] + pref[i + mn - 1][l - 1];
                        if (t == 0) le = mid;
                        else ri = mid;
                    }
                    ans = max(ans, (le + 1) * (k - j + 1));*/
                    int t = mn;
                    while (i + t <= n and t < mn2 and pref[i + t][r] - pref[i + t][l - 1] - pref[i + t - 1][r] + pref[i + t - 1][l - 1] == 0) t++;
                    ans = max(ans, t * (k - j + 1));
                }
            }

            mn = mn2 = n - j + 1;
            l = r = 0;
            for (int k = i; k <= n; ++ k)
            {
                if (len[k][j] == 0 and r == -1) break;
                if (mn == len[k][j])
                {
                    if (r == k - 1) r++;
                    else r = -1;
                }
                else if (mn > len[k][j])
                {
                    mn2 = mn;
                    mn = len[k][j];
                    l = r = k;
                }
                else if (mn2 > len[k][j]) mn2 = len[k][j];
                /// cout << i << " " << j << " " << mn << " " << mn2 << " " << l << " " << r << endl;
                if (r == -1) ans = max(ans, mn * (k - i + 1));
                else
                {
                    /**int le = mn - 1, ri = mn2, mid;
                    while (ri - le > 1)
                    {
                        mid = (le + ri) / 2;
                        /// iskame da proverim za pravougulnika s goren lqv krai (l, j + mn) i dolen desen krai (r, j + mid - 1)
                        int t = pref[r][j + mid - 1] - pref[r][j + mn - 1] - pref[l - 1][j + mid - 1] + pref[l - 1][j + mn - 1];
                        if (t == 0) le = mid;
                        else ri = mid;
                    }
                    ans = max(ans, (le + 1) * (k - i + 1));*/
                    int t = mn;
                    while (j + t <= n and t < mn2 and pref[r][j + t] - pref[l - 1][j + t] - pref[r][j + t - 1] + pref[l - 1][j + t - 1] == 0) t++;
                    ///cout << i << " " << j << " " << k << " " << t << endl;
                    ans = max(ans, t * (k - i + 1));
                    ///cout << ans << endl;
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}
/**
5
11111
11110
11101
11011
10111
*/
