#include <iostream>
#include <string>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int n;
time_t start;
int tab[MAXN + 5][MAXN + 5][2];
int dep[MAXN + 5][MAXN + 5][2];
int len[MAXN + 5][MAXN + 5][2];
int pref[MAXN + 5][MAXN + 5][2];

int solve()
{
    int ans = 0;
    for (int i = n; i >= 1; -- i)
    {
        for (int j = n; j >= 1; -- j)
        {
            for (int b = 0; b <= 1; ++ b)
            {
                if (tab[i][j][b] == 0) dep[i][j][b] = len[i][j][b] = 0;
                else
                {
                    dep[i][j][b] = dep[i + 1][j][b] + 1;
                    len[i][j][b] = len[i][j + 1][b] + 1;
                }
            }
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            for (int b = 0; b <= 1; ++ b)
            {
                int mn = n - i + 1, mn2 = n - i + 1, l = 0, r = 0, opt = 0;
                for (int k = j; k <= n; ++ k)
                {
                    if (dep[i][k][b] == 0 and r == -1) break;
                    if ((k - j + 1) * opt < ans) continue;
                    if (mn == dep[i][k][b])
                    {
                        if (r == k - 1) r++;
                        else r = -1;
                    }
                    else if (mn > dep[i][k][b])
                    {
                        mn2 = mn;
                        mn = dep[i][k][b];
                        l = r = k;
                    }
                    else if (mn2 > dep[i][k][b]) mn2 = dep[i][k][b];
                    if (r == -1) ans = max(ans, mn * (k - j + 1)), opt = mn;
                    else
                    {
                        int le = mn, ri = mn2 + 1, mid;
                        while (ri - le > 1)
                        {
                            mid = (le + ri) / 2;
                            /// iskame da proverim za pravougulnika s goren lqv krai (i + mn, l) i dolen desen krai (i + mid - 1, r)
                            int t = pref[i + mid - 1][r][b] - pref[i + mn - 1][r][b] - pref[i + mid - 1][l - 1][b] + pref[i + mn - 1][l - 1][b];
                            if (t == 0) le = mid;
                            else ri = mid;
                        }
                        int MINUS = (le - mn) * (r - l + 1);
                        int le2 = le, ri2 = n - i + 2, mid2;
                        while (ri2 - le2 > 1)
                        {
                            mid2 = (le2 + ri2) / 2;
                            int t = pref[i + mid2 - 1][k][b] - pref[i + mid2 - 1][j - 1][b] - pref[i - 1][k][b] + pref[i - 1][j - 1][b];
                            if (t == mid2 * (k - j + 1) - MINUS) le2 = mid2;
                            else ri2 = mid2;
                        }
                        ans = max(ans, le2 * (k - j + 1));
                        opt = le2;
                    }
                }

                mn = mn2 = n - j + 1;
                l = r = 0;
                opt = 0;
                for (int k = i; k <= n; ++ k)
                {
                    if (len[k][j][b] == 0 and r == -1) break;
                    if ((k - i + 1) * opt < ans) continue;
                    if (mn == len[k][j][b])
                    {
                        if (r == k - 1) r++;
                        else r = -1;
                    }
                    else if (mn > len[k][j][b])
                    {
                        mn2 = mn;
                        mn = len[k][j][b];
                        l = r = k;
                    }
                    else if (mn2 > len[k][j][b]) mn2 = len[k][j][b], opt = mn;
                    if (r == -1) ans = max(ans, mn * (k - i + 1));
                    else
                    {
                        int le = mn, ri = mn2 + 1, mid;
                        while (ri - le > 1)
                        {
                            mid = (le + ri) / 2;
                            /// iskame da proverim za pravougulnika s goren lqv krai (l, j + mn) i dolen desen krai (r, j + mid - 1)
                            int t = pref[r][j + mid - 1][b] - pref[r][j + mn - 1][b] - pref[l - 1][j + mid - 1][b] + pref[l - 1][j + mn - 1][b];
                            if (t == 0) le = mid;
                            else ri = mid;
                        }
                        int MINUS = (le - mn) * (r - l + 1);
                        int le2 = le, ri2 = n - j + 2, mid2;
                        while (ri2 - le2 > 1)
                        {
                            mid2 = (le2 + ri2) / 2;
                            int t = pref[k][j + mid2 - 1][b] - pref[i - 1][j + mid2 - 1][b] - pref[k][j - 1][b] + pref[i - 1][j - 1][b];
                            if (t == mid2 * (k - i + 1) - MINUS) le2 = mid2;
                            else ri2 = mid2;
                        }
                        ans = max(ans, le2 * (k - i + 1));
                        opt = le2;
                    }
                }
                if (clock() - start > 2.495 * CLOCKS_PER_SEC) return ans;
            }
        }
    }
    return ans;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    start = clock();

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        string s;
        cin >> s;

        for (int j = 1; j <= n; ++ j)
        {
            tab[i][j][0] = (s[j - 1] - '0');
            pref[i][j][0] = pref[i - 1][j][0] + pref[i][j - 1][0] - pref[i - 1][j - 1][0] + tab[i][j][0];
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            tab[i][j][1] = tab[n + 1 - i][n + 1 - j][0];
            pref[i][j][1] = pref[i - 1][j][1] + pref[i][j - 1][1] - pref[i - 1][j - 1][1] + tab[i][j][1];
        }
    }

    cout << solve() << endl;

    return 0;
}
/**
5
11111
11110
11101
11011
10111
*/
