#include <bits/stdc++.h>
#define endl "\n"
#define pii pair<int, int>
#define ff first
#define ss second
using namespace std;

const int maxn = 2e3+3;

int matrix[maxn][maxn];
int rows[maxn][maxn], n;

int fxb = -1, fxe = -1, fyb = -1, fye = -1;
bool in_bounds(const int& x, const int& y)
{
    if(x < fxb || fxe < x || y < fyb || fye < y) return false;
    return true;
}

void input()
{
    char c;
    cin >> n;
    for(int i = 1; i <= n; i++)
    for(int j = 1; j <= n; j++)
    {
        cin >> c;
        matrix[i][j] = (c == '1');
    }
}

void do_rows()
{
    for(int i = 1; i <= n; i++)
    for(int j = 1; j <= n; j++)
    {
        rows[i][j] = (rows[i][j-1] + 1) * (matrix[i][j] ^ in_bounds(i, j));
    }
}

int minleft[maxn], minright[maxn];
int do_column(int j)
{
    stack<pii> st;

    // left to right
    for(int i = 1; i <= n; i++)
    {
        while(!st.empty() && st.top().ff >= rows[i][j])
            st.pop();
        if(st.empty()) minleft[i] = 0;
        else minleft[i] = st.top().ss;
        st.push({rows[i][j], i});
    }

    // right to left
    for(int i = n; i >= 1; i--)
    {
        while(!st.empty() && st.top().ff >= rows[i][j])
            st.pop();
        if(st.empty()) minright[i] = n+1;
        else minright[i] = st.top().ss;
        st.push({rows[i][j], i});
    }

    int result = 0;
    for(int i = 1; i <= n; i++)
        result = max(result, (minright[i] - minleft[i] - 1) * rows[i][j]);
    return result;
}

int do_columns()
{
    int result = 0;
    for(int j = 1; j <= n; j++)
        result = max(result, do_column(j));
    return result;
}

int calculate()
{
    do_rows();
    return do_columns();
}

void attempt_to_solve()
{
    int result = calculate();
    for(int lowx = 1; lowx <= n; lowx++)
    for(int lowy = 1; lowy <= n; lowy++)
    {
        //if(matrix[lowx][lowy]) continue;
        for(int highx = lowx; highx <= n; highx++)
        for(int highy = lowy; highy <= n; highy++)
        {
            fxb = lowx, fxe = highx, fyb = lowy, fye = highy;
            result = max(result, calculate());
        }
    }
    cout << result << endl;
}

int main()
{
    input();
    attempt_to_solve();
    return 0;
}
