#include <bits/stdc++.h>
#include "treeq.h"

typedef long long ll;
typedef long double ld;

const ll Size=2e3+1,mod=1e9+7;
bool is_edge[Size][Size];
std::vector<int> ancesters[Size];
const ll root=1;

bool query(std::vector<int> S, int x);/*{
    bool t;
    for(ll i=0;i<S.size();i++){
        std::cout<<S[i]<<" ";
    }
    std::cout<<" "<<x<<":";
    std::cin>>t;
    return t;
}
*/
void answer(int u,int v);/*{
    std::cout<<u<<" "<<v<<std::endl;
}
*/
void solve(int n){
    std::vector<int> to_check;
    to_check.push_back(root);
    for(ll i=1;i<=n;i++){
        if(i==root)
            continue;
        ancesters[i].push_back(root);
        to_check.push_back(i);
        bool edge=true;
        for(ll j=i+1;j<=n;j++){
            if(j==root)
                continue;
            if(j!=i){
                // j on path 1-i
                bool res=query(to_check,j);
                if(res){
                    ancesters[i].push_back(j);
                }else{
                    to_check.pop_back();
                    to_check.push_back(j);
                    // i on path 1-j
                    res=query(to_check,i);
                    if(res){
                        ancesters[j].push_back(i);
                    }
                    to_check.pop_back();
                    to_check.push_back(i);
                }
            }
        }
        to_check.pop_back();
    }
    for(ll i=1;i<=n;i++){
        for(auto itrv:ancesters[i]){
            if(std::max(ancesters[i].size(),ancesters[itrv].size())-std::min(ancesters[i].size(),ancesters[itrv].size())==1){
                is_edge[i][itrv]=1;
                is_edge[itrv][i]=1;
            }
        }
    }
    for(ll i=1;i<=n;i++){
        for(ll j=i+1;j<=n;j++){
            if(is_edge[i][j]){
                answer(i,j);
            }
        }
    }
}
/*
int main(){
    solve(5);
    return 0;
}

*/
