#include <iostream>
#include <vector>
#include <utility>

#include "treeq.h"

using namespace std;

vector<pair<int, int>> edges;

void solve(int n) {
    for (int from = 1; from <= n and (int) edges.size() < n - 1; ++from)
    {
        for (int to = from + 1; to <= n and (int) edges.size() < n - 1; ++to)
        {
            bool is_edge = true;

            for (int special = 1; special <= n; ++special)
            {
                if (from == special or to == special)
                {
                    continue;
                }

                if (query({from, to}, special))
                {
                    is_edge = false;
                    break;
                }
            }

            if (is_edge)
            {
                edges.push_back({from, to});
            }
        }
    }

    for (pair<int, int> edge : edges)
    {
        answer(edge.first, edge.second);
    }
}
