#pragma GCC optimize("O3")

#include <iostream>

#define MAX_B 8
#define MAX_N 256

int n, b;
int u[MAX_N+1];

int ways[1<<MAX_B];
int ways_new[1<<MAX_B];

int k;

int cin_binary() {
	int ret = 0;
	for (int i = 0; i < b; i += 1) {
		char c;
		std::cin >> c;
		ret <<= 1;
		if (c == '1') ret |= 1;
	}
	return ret;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	
	std::cin >> n >> b;
	k = cin_binary();
	for (int i = 0; i < n; i += 1) {
		u[i] = cin_binary();
	}
	
	ways[0] = 1;
	
	for (int i = 0; i < n; i += 1) {
		for (int i = 0; i < 1<<b; i += 1) ways_new[i] = 0;
		for (int x = 0; x <= u[i]; x += 1) {
			for (int old = 0; old < 1<<b; old += 1) {
				ways_new[old^x] += ways[old];
			}
		}
		for (int i = 0; i < 1<<b; i += 1) ways[i] = ways_new[i];
	}
	
	std::cout << ways[k] << std::endl;
}