#include<bits/stdc++.h>
#include "treeq.h"
#define MAXN 2007
using namespace std;

int n;
vector<int> v,t[MAXN];
int li[MAXN],tim,sum;
int in[MAXN],out[MAXN],num;

bool subtree(int x,int y){
    return in[x]>=in[y] and out[x]<=out[y];
}

void dfs(int x,int p){
    num++; in[x]=num;
    for(int i=0;i<t[x].size();i++){
        if(t[x][i]==p)continue;
        dfs(t[x][i],x);
    }
    out[x]=num;
}

void tree(vector<int> w){
    if(w.size()==1)return;
    if(w.size()==2){
        answer(w[0],w[1]);
        t[w[0]].push_back(w[1]);
        t[w[1]].push_back(w[0]);
        return;
    }

    int root=w[rand()%int(w.size())];

    vector<int> z={};
    for(int i=0;i<w.size();i++){
        if(w[i]==root)continue;
        z.push_back(w[i]);
    }

    tim++; sum+=w.size();
    vector< vector<int> > comps;

    if(!query(z,root)){
        comps.push_back(z);
    }else{
        for(int i=0;i<w.size();i++){
            if(w[i]==root or li[w[i]]==tim)continue;
            comps.push_back({w[i]});
            for(int f=i+1;f<w.size();f++){
                if(li[w[f]]!=tim and !query({w[i],w[f]},root)){
                    comps.back().push_back(w[f]);
                    li[w[f]]=tim;
                }
            }
        }
    }

    for(int i=0;i<comps.size();i++){
        tree(comps[i]);
    }

    int child=0;
    for(int i=0;i<comps.size();i++){
        child=comps[i][0]; num=0;
        dfs(comps[i][0],0);

        for(int f=1;f<comps[i].size();f++){
            if(subtree(comps[i][f],child) and query({child,root},comps[i][f])){
                child=comps[i][f];
            }
        }

        t[root].push_back(child);
        t[child].push_back(root);
        answer(root,child);
    }
}

void solve(int N){

    srand(7073);

    n=N;
    for(int i=1;i<=n;i++){
        v.push_back(i);
    }

    tree(v);
}
