#include<bits/stdc++.h>
#define MAXN 2007
using namespace std;

struct rect{
    int a,b,c,d;
};

int n,res,last;
char t[MAXN][MAXN];
int s[MAXN],pr[MAXN],nxt[MAXN];
stack<int> st;
vector<rect> e;
int pref[MAXN][MAXN];

int sum(int a,int b,int c,int d){
    return pref[c][d]-pref[a-1][d]-pref[c][b-1]+pref[a-1][b-1];
}

int solve(){
    s[0]=s[n+1]=-1;
    int ans=0;
    for(int i=1;i<=n;i++)s[i]=0;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            if(t[i][f]=='1')s[f]++;
            else s[f]=0;
        }
        for(int f=0;f<=n+1;f++){
            while(!st.empty() and s[f]<=s[st.top()])st.pop();
            if(!st.empty())pr[f]=st.top();
            st.push(f);
        }
        for(int f=n+1;f>=0;f--){
            while(!st.empty() and s[f]<=s[st.top()])st.pop();
            if(!st.empty())nxt[f]=st.top();
            st.push(f);
        }

        for(int f=1;f<=n;f++){
            ans=max(ans,(nxt[f]-pr[f]-1)*s[f]);
        }
    }
    return ans;
}

void flip(int r1,int r2,int c1,int c2){
    for(int i=r1;i<=r2;i++){
        for(int f=c1;f<=c2;f++){
            if(t[i][f]=='0')t[i][f]='1';
            else t[i][f]='0';
        }
    }
}

void findrect(){
    s[0]=s[n+1]=n+1; e.clear();
    for(int i=1;i<=n;i++)s[i]=0;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            if(t[i][f]=='1')s[f]++;
            else s[f]=0;
        }
        for(int f=0;f<=n+1;f++){
            while(!st.empty() and s[f]>=s[st.top()])st.pop();
            if(!st.empty())pr[f]=st.top();
            st.push(f);
        }
        for(int f=n+1;f>=0;f--){
            while(!st.empty() and s[f]>=s[st.top()])st.pop();
            if(!st.empty())nxt[f]=st.top();
            st.push(f);
        }

        for(int f=1;f<=n;f++){
            int l=0,r=i-s[f]+1,mid;
            while(l+1<r){
                mid=(l+r)/2;
                if(sum(mid,pr[f]+1,i-s[f],nxt[f]-1)==0){
                    r=mid;
                }else{
                    l=mid;
                }
            }
            for(int k=i-s[f];k>=1;k--){
                for(int p=pr[f]+1;p<=nxt[f]-1;p++){
                    if(t[k][p]=='1')k=0;
                }
                if(k==0)break;
                e.push_back({k,pr[f]+1,i-s[f],nxt[f]-1});
            }
            if(r<=i-s[f])e.push_back({r,pr[f]+1,i-s[f],nxt[f]-1});
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            cin>>t[i][f];
            pref[i][f]=pref[i-1][f]+pref[i][f-1]-pref[i-1][f-1];
            if(t[i][f]=='1')pref[i][f]++;
        }
    }

    res=max(res,solve());

    findrect();
    for(int i=0;i<e.size();i++){
        flip(e[i].a,e[i].c,e[i].b,e[i].d);
        res=max(res,solve());
        flip(e[i].a,e[i].c,e[i].b,e[i].d);
    }

    for(int i=1;i<=n/2;i++){
        for(int f=1;f<=n;f++){
            swap(t[i][f],t[n-i+1][f]);
        }
    }
    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            pref[i][f]=pref[i-1][f]+pref[i][f-1]-pref[i-1][f-1];
            if(t[i][f]=='1')pref[i][f]++;
        }
    }

    findrect();
    for(int i=0;i<e.size();i++){
        flip(e[i].a,e[i].c,e[i].b,e[i].d);
        res=max(res,solve());
        flip(e[i].a,e[i].c,e[i].b,e[i].d);
    }

    cout<<res<<"\n";

    return 0;
}
