#include<bits/stdc++.h>
#define MAXN 2007
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
using namespace std;

struct rect{
    int a,b,c,d;
};

int n,res,last,minx,maxx;
char t[MAXN][MAXN],temp[MAXN][MAXN];
int s[MAXN],pr[MAXN],nxt[MAXN];
stack<int> st;
vector<rect> e;
int pref[MAXN][MAXN];

int sum(int a,int b,int c,int d){
    return pref[c][d]-pref[a-1][d]-pref[c][b-1]+pref[a-1][b-1];
}

int solve(){
    s[0]=s[n+1]=-1;
    int ans=0;
    for(int i=1;i<=n;i++)s[i]=0;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            if(t[i][f]=='1')s[f]++;
            else s[f]=0;
        }
        if(i<minx)continue;
        
        for(int f=0;f<=n+1;f++){
            while(!st.empty() and s[f]<=s[st.top()])st.pop();
            if(!st.empty())pr[f]=st.top();
            st.push(f);
        }
        for(int f=n+1;f>=0;f--){
            while(!st.empty() and s[f]<=s[st.top()])st.pop();
            if(!st.empty())nxt[f]=st.top();
            st.push(f);
        }

        for(int f=1;f<=n;f++){
            ans=max(ans,(nxt[f]-pr[f]-1)*s[f]);
        }
    }
    return ans;
}

void flip(int r1,int r2,int c1,int c2){
    for(int i=r1;i<=r2;i++){
        for(int f=c1;f<=c2;f++){
            if(t[i][f]=='0')t[i][f]='1';
            else t[i][f]='0';
        }
    }
}

void findrect(){
    s[0]=s[n+1]=n+1; e.clear();
    for(int i=1;i<=n;i++)s[i]=0;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            if(t[i][f]=='1')s[f]++;
            else s[f]=0;
        }

        for(int f=0;f<=n+1;f++){
            while(!st.empty() and s[f]>=s[st.top()])st.pop();
            if(!st.empty())pr[f]=st.top();
            st.push(f);
        }
        for(int f=n+1;f>=0;f--){
            while(!st.empty() and s[f]>=s[st.top()])st.pop();
            if(!st.empty())nxt[f]=st.top();
            st.push(f);
        }

        for(int f=1;f<=n;f++){
            int l=0,r=i-s[f]+1,mid;
            while(l+1<r){
                mid=(l+r)/2;
                if(sum(mid,pr[f]+1,i-s[f],nxt[f]-1)==0){
                    r=mid;
                }else{
                    l=mid;
                }
            }
            if(r<=i-s[f])e.push_back({r,pr[f]+1,i-s[f],nxt[f]-1});
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            cin>>t[i][f];
            pref[i][f]=pref[i-1][f]+pref[i][f-1]-pref[i-1][f-1];
            if(t[i][f]=='1')pref[i][f]++;
        }
    }

    res=max(res,solve());

    for(int test=1;test<=4;test++){

        findrect();
        for(int i=0;i<e.size();i++){
            flip(e[i].a,e[i].c,e[i].b,e[i].d);
            minx=e[i].a; maxx=e[i].c;
            res=max(res,solve());
            flip(e[i].a,e[i].c,e[i].b,e[i].d);
        }

        for(int i=1;i<=n;i++){
            for(int f=1;f<=n;f++){
                temp[i][f]=t[n-f+1][i];
            }
        }
        for(int i=1;i<=n;i++){
            for(int f=1;f<=n;f++){
                t[i][f]=temp[i][f];
                pref[i][f]=pref[i-1][f]+pref[i][f-1]-pref[i-1][f-1];
                if(t[i][f]=='1')pref[i][f]++;
            }
        }

    }

    cout<<res<<"\n";

    return 0;
}
