#include "treeq.h"

#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx512")
using namespace std;
#define endl "\n"
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll mod = 1e9 + 7;

void recur(vector<int> &vert, int ahint = -1, int bhint = -1) {
    if(vert.size() == 1) {
        return;
    }
    if(vert.size() == 2) {
        answer(vert[0], vert[1]);
        return;
    }

    int a = ahint == -1 ? vert[rand() % vert.size()] : ahint;
    int b = bhint == -1 ? vert[rand() % vert.size()] : bhint;
    while(a == b) {
        b = vert[rand() % vert.size()];
    }

    for(const auto x : vert) {
        if(x == a || x == b) { continue; }
        if(query({a, b}, x)) {
            b = x;
        }
    }
    answer(a, b);

    vector<int> lft = {a}, rght = {b};
    for(const auto x : vert) {
        if(x == a || x == b) { continue; }
        if(query({a, x}, b)) {
            rght.push_back(x);
        } else {
            lft.push_back(x);
        }
    }

    recur(lft, a, -1);
    recur(rght, b, -1);
}

void solve(int n) {
    vector<int> all = {};
    for(int i = 1; i <= n; i ++) {
        all.push_back(i);
    }
    recur(all);
}

/*
5
1 3
1 5
5 2
5 4
*/
