#include "treeq.h"


#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx512")
using namespace std;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll mod = 1e9 + 7;

void recur(vector<int> &vert) {
    if(vert.size() == 1) {
        return;
    }
    if(vert.size() == 2) {
        answer(vert[0], vert[1]);
        return;
    }
    int a = vert[rand() % vert.size()];
    int b = vert[rand() % vert.size()];
    while(a == b) {
        b = vert[rand() % vert.size()];
    }

    vector<int> path = {a, b};
    set<int> st;
    st.insert(a); st.insert(b);

    for(int i = 0; i < 20; i ++) {
        int c = vert[rand() % vert.size()];
        while(st.count(c) && st.size() < vert.size()) {
            c = vert[rand() % vert.size()];
        }
        if(st.size() < vert.size()) { break; }
        if(query({a, c}, b)) {
            used.insert(c);
            b = c;
            path.push_back(c);
        }
    }

    for(const auto x : vert) {
        if(st.count(x)) { continue; }
        if(query({a, b}, x)) {
            int l = 0, r = path.size() - 1;
            while(l < r - 1) {
                int m = (l + r) / 2ll;
                if(query({path[m], b}, x)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            path.push_back(0);
            for(int i = path.size() - 1; i - 1 > l; i --) {
                path[i] = path[i - 1];
            }
            path[l + 1] = x;
            st.insert(x);
        }
    }

    for(int i = 0; i < path.size() - 1; i ++) {
        answer(path[i], path[i + 1]);
    }

    vector<vector<int> > sub(path.size());
    for(const auto x : vert) {
        if(st.count(x)) { continue; }
        if(query({a, x}, b)) {
            sub[path.size() - 1].push_back(x);
            continue;
        }
        int l = 0, r = path.size() - 1;
        while(l < r - 1) {
            int m = (l + r) / 2ll;
            if(query({a, x}, path[m])) {
                l = m;
            } else {
                r = m;
            }
        }
        sub[l].push_back(x);
    }

    for(int i = 0; i < path.size(); i ++) {
        sub[i].push_back(path[i]);
        recur(sub[i]);
    }
}

void solve(int n) {
    vector<int> all = {};
    for(int i = 1; i <= n; i ++) {
        all.push_back(i);
    }
    recur(all);
}

/*
5
1 3
1 5
5 2
5 4
*/
