#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
using namespace std;
#define endl "\n"
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll mod = 998244354;

const int MAX_N = 3e3 + 10;

string inp[MAX_N + 1];
int n, b;

ll dp[MAX_N][2][2];
vector<ll> suf[MAX_N];
ll pw[MAX_N];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif

    pw[0] = 1;
    for(int i = 1; i < MAX_N; i ++) {
        pw[i] = (pw[i - 1] * 2ll) % mod;
    }

    cin >> n >> b;
    cin >> inp[n];
    for(int i = 0; i < n; i ++) {
        cin >> inp[i];
        suf[i].resize(b + 1);
        suf[i][b] = 1;
        for(int j = b - 1; j >= 0; j --) {
            suf[i][j] = (((inp[i][b - 1] == '1') ? pw[b - j - 1] : 0) + suf[i][j + 1]) % mod;
        }
    }

    ll ret = 0;

    bool ok = true;
    for(int bit = 0; bit < b; bit ++) {
        int cnt = 0;
        for(int i = 0; i <= n; i ++) {
            if(inp[i][bit] == '1') {
                cnt ++;
            }
            dp[i][0][0] = dp[i][0][1] = dp[i][1][0] = dp[i][1][1] = 0;
        }

        dp[0][0][0] = 1;
        for(int i = 0; i < n; i ++) {
            for(int used = 0; used < 2; used ++) {
                for(int flag = 0; flag < 2; flag ++) {
                    if(inp[i][bit] == '1') {
                        dp[i + 1][used][flag ^ 1] += (dp[i][used][flag] * suf[i][bit + 1]) % mod;
                        dp[i + 1][used][flag ^ 1] %= mod;
                        if(!used) {
                            dp[i + 1][true][flag] += dp[i][used][flag];
                            dp[i + 1][true][flag] %= mod;
                        } else {
                            dp[i + 1][used][flag] += (dp[i][used][flag] * pw[b - bit - 1]) % mod;
                            dp[i + 1][used][flag] %= mod;
                        }
                    } else {
                        dp[i + 1][used][flag] += (dp[i][used][flag] * suf[i][bit]) % mod;
                        dp[i + 1][used][flag] %= mod;
                    }
                }
            }
        }

        if(ok) {
            ret = (ret + dp[n][1][inp[n][bit] == '1']) % mod;
        }
        ok &= (inp[n][bit] == '1') == cnt % 2;
    }

    if(ok) {
        ret = (ret + 1) % mod;
    }
    cout << ret << endl;

    return 0;
}

/*
2 3
000
111
100
*/
