#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
using namespace std;
#define endl "\n"
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll mod = 998244354;

const int MAX_N = 1e7 + 10;

string inp[MAX_N + 1];
int n, b;
int suf[MAX_N];

ll dp[2][2][2];

ll fpow(ll x, ll p) {
    if(p == 0) { return 1; }
    ll ans = fpow(x, p / 2);
    ans = (ans * ans) % mod;
    if(p & 1) {
        return (ans * x) % mod;
    } else {
        return ans;
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif

    cin >> n >> b;
    cin >> inp[n];
    for(int i = 0; i < n; i ++) {
        cin >> inp[i];
        suf[i] = 1;
        for(int j = b - 1; j >= 0; j --) {
            suf[i] = (((inp[i][j] == '1') ? fpow(2, b - j - 1) : 0) + suf[i]) % mod;
        }
    }

    ll ret = 0;

    bool ok = true;
    for(int bit = 0; bit < b; bit ++) {
        int cnt = 0;
        for(int i = 0; i < n; i ++) {
            if(inp[i][bit] == '1') {
                cnt ++;
            }
        }
        for(int i = 0; i < 2; i ++) {
            for(int j = 0; j < 2; j ++) {
                for(int k = 0; k < 2; k ++) {
                    dp[i][j][k] = 0;
                }
            }
        }

        dp[0][0][0] = 1;
        for(int i = 0; i < n; i ++) {
            int curr = i & 1, nxt = curr ^ 1;
            for(int used = 0; used < 2; used ++) {
                for(int flag = 0; flag < 2; flag ++) {
                    dp[nxt][used][flag] = 0;
                }
            }

            ll currsuf = suf[i];
            ll nextsuf = (suf[i] - ((inp[i][bit] == '1') ? fpow(2, b - bit - 1) : 0) + mod) % mod;

            for(int used = 0; used < 2; used ++) {
                for(int flag = 0; flag < 2; flag ++) {
                    if(inp[i][bit] == '1') {
                        dp[nxt][used][flag ^ 1] += (dp[curr][used][flag] * nextsuf) % mod;
                        dp[nxt][used][flag ^ 1] %= mod;
                        if(!used) {
                            dp[nxt][true][flag] += dp[curr][used][flag];
                            dp[nxt][true][flag] %= mod;
                        } else {
                            dp[nxt][used][flag] += (dp[curr][used][flag] * fpow(2, b - bit - 1)) % mod;
                            dp[nxt][used][flag] %= mod;
                        }
                    } else {
                        dp[nxt][used][flag] += (dp[curr][used][flag] * currsuf) % mod;
                        dp[nxt][used][flag] %= mod;
                    }
                }
            }

            suf[i] = nextsuf;
        }

        if(ok) {
            ret = (ret + dp[n & 1][1][inp[n][bit] == '1']) % mod;
        }
        ok &= (inp[n][bit] == '1') == cnt % 2;
    }

    if(ok) {
        ret = (ret + 1) % mod;
    }
    cout << ret << endl;

    return 0;
}

/*
2 3
000
111
100
*/
