/**
    Зам деле думля да
    зам деле думля да
    зам деле деле деле
    думля да да да да
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <cstring>
#include <vector>
#include <stack>
#include <queue>
#include <bitset>
#include <set>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int MOD  = 998244354;
const int INF  = 1e9;

int n, b;
char k[MAXN];
std::bitset <MAXN> a;
std::string s;
int suffSum[MAXN];
int dp[MAXN][2];
int pow[MAXN];

void solve()
{
    pow[0] = 1;
    for (int i = 1 ; i <= b ; ++i)
    {
        pow[i] = pow[i - 1] * 2;
        if (pow[i] >= MOD) pow[i] -= MOD;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = b - 1 ; j >= 0 ; --j)
        {
            suffSum[i * (b + 1) + j] = suffSum[i * (b + 1) + j + 1];
            if (a[(i - 1) * b + j] == 1)
            {
                suffSum[i * (b + 1) + j] += pow[b - 1 - j];
                if (suffSum[i * (b + 1) + j] >= MOD)
                {
                    suffSum[i * (b + 1) + j] -= MOD;
                }
            }
        }
    }

    int ans = 0;
    for (int bit = 0 ; bit < b ; ++bit)
    {
        int currXor = 0;
        int currBit = k[bit] - '0';
        llong mult = 1;

        memset(dp, 0, sizeof(dp));
        dp[n + 1][0] = 1;

        for (int i = n ; i > 0 ; --i)
        {
            for (int curr = 0 ; curr < 2 ; ++curr)
            {
                if (a[(i - 1) * b + bit] == 0)
                {
                    dp[i][curr] += (1LL * dp[i + 1][curr] * (suffSum[i * (b + 1) + bit + 1] + 1)) % MOD;
                } else
                {
                    dp[i][curr] += (1LL * dp[i + 1][curr ^ 1] * (suffSum[i * (b + 1) + bit + 1] + 1)) % MOD;
                    dp[i][curr] += (1LL * dp[i + 1][curr] * pow[b - bit - 1]) % MOD;
                    if (dp[i][curr] >= MOD) dp[i][curr] -= MOD;
                }
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            if (a[(i - 1) * b + bit] == 1)
            {
                ans += (dp[i + 1][currXor ^ currBit] * mult) % MOD;
                if (ans >= MOD) ans -= MOD;
            }

            currXor ^= a[(i - 1) * b + bit];
            mult *= suffSum[i * (b + 1) + bit + 1] + 1;
            mult %= MOD;
        }

        if (currXor != currBit)
        {
            break;
        }

        if (bit == b - 1)
        {
            ans++;
            if (ans == MOD)
            {
                ans -= MOD;
            }
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> b;
    std::cin >> k;

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> s;
        for (int j = 0 ; j < b ; ++j)
        {
            a[(i - 1) * b + j] = s[j] - '0';
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}

/**
3 3
111
110
101
001
2 4 1
2 5 0
3 4 0
3 5 1
4 2 1
4 3 0
5 2 0
5 3 1
6 0 1
6 1 0
*/
