/**
    Зам деле думля да
    зам деле думля да
    зам деле деле деле
    думля да да да да
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <cstring>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int MOD  = 998244354;
const int INF  = 1e9;

int n, b;
char k[MAXN];
std::string s;
std::vector <int> suffSum[MAXN];
int dp[MAXN][2];
int pow[MAXN];

struct Bitset
{
    std::vector <unsigned long long> nums;
    void build(int sz)
    {
        nums.resize(sz / 64 + 1, 0);
    }

    void set(int bit, int val)
    {
        if (val == 1)
        {
            nums[bit >> 6] ^= (1LL << (bit & 63));
        }
    }

    bool get(int bit)
    {
        return nums[bit >> 6] & (1LL << (bit & 63));
    }
};

std::vector <Bitset> a;
void solve()
{
    pow[0] = 1;
    for (int i = 1 ; i <= b ; ++i)
    {
        pow[i] = pow[i - 1] * 2;
        if (pow[i] >= MOD) pow[i] -= MOD;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        suffSum[i].resize(b + 1, 0);
        for (int j = b - 1 ; j >= 0 ; --j)
        {
            suffSum[i][j] = suffSum[i][j + 1];
            if (a[i].get(j) == 1)
            {
                suffSum[i][j] += pow[b - 1 - j];
                if (suffSum[i][j] >= MOD)
                {
                    suffSum[i][j] -= MOD;
                }
            }
        }
    }

    int ans = 0;
    for (int bit = 0 ; bit < b ; ++bit)
    {
        int currXor = 0;
        int currBit = k[bit] - '0';
        llong mult = 1;

        dp[n + 1][0] = 1;
        dp[n + 1][0] = 0;

        for (int i = n ; i > 0 ; --i)
        {
            for (int curr = 0 ; curr < 2 ; ++curr)
            {
                dp[i][curr] = 0;
                if (a[i].get(bit) == 0)
                {
                    dp[i][curr] += (1LL * dp[i + 1][curr] * (suffSum[i][bit + 1] + 1)) % MOD;
                } else
                {
                    dp[i][curr] += (1LL * dp[i + 1][curr ^ 1] * (suffSum[i][bit + 1] + 1)) % MOD;
                    dp[i][curr] += (1LL * dp[i + 1][curr] * pow[b - bit - 1]) % MOD;
                    if (dp[i][curr] >= MOD) dp[i][curr] -= MOD;
                }
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            if (a[i].get(bit) == 1)
            {
                ans += (dp[i + 1][currXor ^ currBit] * mult) % MOD;
                if (ans >= MOD) ans -= MOD;
            }

            currXor ^= a[i].get(bit);
            mult *= suffSum[i][bit + 1] + 1;
            mult %= MOD;
        }

        if (currXor != currBit)
        {
            break;
        }

        if (bit == b - 1)
        {
            ans++;
            if (ans == MOD)
            {
                ans -= MOD;
            }
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> b;
    std::cin >> k;

    a.resize(n + 1);
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i].build(b);
        std::cin >> s;
        for (int j = 0 ; j < b ; ++j)
        {
            a[i].set(j, s[j] - '0');
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}

/**
3 3
111
110
101
001
2 4 1
2 5 0
3 4 0
3 5 1
4 2 1
4 3 0
5 2 0
5 3 1
6 0 1
6 1 0
*/
