/**
    Зам деле думля да
    зам деле думля да
    зам деле деле деле
    думля да да да да
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 2000 + 10;
const int INF  = 1e9;

int n, m;
bool t[MAXN][MAXN];
char s[MAXN][MAXN];
int p[MAXN][MAXN];
int firstOne[MAXN][MAXN];
int firstZero[MAXN][MAXN];
std::vector <int> v;

int checkSum(int row1, int col1, int row2, int col2)
{
    --row1; --col1;
    return p[row2][col2] - p[row1][col2] - p[row2][col1] + p[row1][col1];
}

bool check(int row1, int col1, int row2, int col2)
{
    int minR = INF, minC = INF;
    int maxR = 0, maxC = 0;
    for (int i = row1 ; i <= row2 ; ++i)
    {
        for (int j = col1 ; j <= col2 ; ++j)
        {
            if (t[i][j] == 1)
            {
                continue;
            }

            if (i < minR)
            {
                minR = i;
                minC = j;
            }

            maxR = i;
            maxC = j;
        }
    }

    if (minC == INF)
    {
        return true;
    }

    if (checkSum(minR, minC, maxR, maxC) != checkSum(row1, col1, row2, col2))
    {
        return false;
    }

    if (checkSum(minR, minC, maxR, maxC) != (maxR - minR + 1) * (maxC - minC + 1))
    {
        return false;
    }

    return true;
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= n ; ++j)
        {
            p[i][j] = p[i - 1][j] + p[i][j - 1] - p[i - 1][j - 1] + 1 - t[i][j];
        }
    }

    int ans = 0;
    for (int i = 1 ; i <= 1 ; ++i)
    {
        for (int j = 1 ; j <= 1 ; ++j)
        {
            for (int i1 = 1 ; i1 <= 1 ; ++i1)
            {
                for (int j1 = 3 ; j1 <= 3 ; ++j1)
                {
                    if (check(i, j, i1, j1))
                    {
                        ans = std::max(ans, (i1 - i + 1) * (j1 - j + 1));
                    }
                }
            }
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> s[i] + 1;
        for (int j = 1 ; j <= n ; ++j)
        {
            t[i][j] = s[i][j] - '0';
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
