#include "treeq.h"
#include <bits/stdc++.h>

using namespace std;


int f, t;
bool cmp(int a, int b)
{
    vector < int > pt;
    pt.push_back(f);
    pt.push_back(b);
    if (query(pt, a))
        return true;
    return false;
}

int get_root(vector < int > st)
{
    int idx1 = rand() % st.size();
    int idx2 = rand() % st.size();

    if (idx1 == idx2)
        idx2 ++;
    if (idx2 == st.size())
        idx2 = 0;

    int v = st[idx1];
    int u = st[idx2];

    vector < int > path;
    vector < int > cur;
    cur.push_back(v);
    cur.push_back(u);

    for (int i = 0; i < st.size(); i ++)
    {
        if (v == st[i] || u == st[i])
            continue;
        if (query(cur, st[i]))
            return st[i];

    }
    return -1;

}
void sub_solve(vector < int > st)
{
    if (st.size() < 2)
        return;
    if (st.size() == 2)
    {
        answer(st[0], st[1]);
        return;
    }

    int idx1 = rand() % st.size();
    int idx2 = rand() % st.size();

    if (idx1 == idx2)
        idx2 ++;
    if (idx2 == st.size())
        idx2 = 0;

    int v = st[idx1];
    int u = st[idx2];

    vector < int > path;
    vector < int > cur;
    cur.push_back(v);
    cur.push_back(u);
    vector < int > lf, rf;
    lf.push_back(v);
    rf.push_back(u);
    vector < int > opt;
    for (int i = 0; i < st.size(); i ++)
    {
        if (v == st[i] || u == st[i])
            continue;
        if (query(cur, st[i]))
            path.push_back(st[i]);
        else
        {
            vector < int > mb;
            mb.push_back(st[i]);
            mb.push_back(u);
            if (query(mb, v))
                lf.push_back(st[i]);
            else
            {
                mb.pop_back();
                mb.push_back(v);
                if (query(mb, u))
                    rf.push_back(st[i]);
                else
                    opt.push_back(st[i]);
            }
        }
    }

    sub_solve(lf);
    sub_solve(rf);

    f = v;
    t = u;
    sort(path.begin(), path.end(), cmp);
    if (path.size() != 0)
    {
        answer(v, path[0]);
        answer(u, path.back());
        for (int i = 1; i < path.size(); i ++)
        {
            answer(path[i - 1], path[i]);
        }
    }
    else
    {
        answer(v, u);

    }
    vector < vector < int > > sb;
    sb.resize(path.size());
    for (int d : opt)
    {
        int left = 0, right = path.size() - 1;
        vector < int > mb;
        mb.push_back(v);
        mb.push_back(d);
        while(left <= right)
        {
            int mid = (left + right) / 2;
            if (query(mb, path[mid]))
                left = mid + 1;
            else
                right = mid - 1;
        }
        sb[right].push_back(d);
        /**int pt = 0;

        while(pt < path.size() && query(mb, path[pt]))
            pt ++;
        pt --;
        sb[pt].push_back(d);*/
    }
    for (int i = 0; i < path.size(); i ++)
    {
        sb[i].push_back(path[i]);
        sub_solve(sb[i]);
    }




}

void sub_block(vector < int > st, int last_root = -1)
{
    /**cout << "--------------" << endl;
    cout << st.size() << endl;
    for (int v : st)
        cout << v << " ";
    cout << endl;*/
    if (st.size() < 2)
        return;
    if (st.size() == 2)
    {
        answer(st[0], st[1]);
        return;
    }


    int root;
    if (last_root != -1)
        root = last_root;
    else
    {
        while(true)

        {
            root = get_root(st);

            if (root == -1)
                continue;
            break;
        }
    }


    vector < vector < int > > block;
    vector < int > trash;
    for (int i = 0; i < st.size(); i ++)
    {
        if (st[i] == root)
            continue;
        if (true)
        {
            bool tf = false;
            for (int j = 0; j < block.size(); j ++)
            {
                vector < int > mb;
                mb.push_back(block[j].back());
                mb.push_back(st[i]);
                if (!query(mb, root))
                {
                    block[j].push_back(st[i]);
                    tf = true;
                    break;
                }
            }
            if (!tf)
            {
                vector < int > new_block;
                new_block.push_back(st[i]);
                block.push_back(new_block);
            }
        }
        else
        {

            bool tf = false;
            for (int j = 0; j < block.size(); j ++)
            {
                vector < int > mb;
                mb.push_back(block[j].back());
                mb.push_back(st[i]);
                if (!query(mb, root))
                {
                    block[j].push_back(st[i]);
                    tf = true;
                    break;
                }
            }
            if (!tf)
            {
                trash.push_back(st[i]);
            }
        }
    }

    trash.push_back(root);
    sub_block(trash, root);
    for (int i = 0; i < block.size(); i ++)
    {
        block[i].push_back(root);
        sub_block(block[i]);
    }
}
void solve(int n)
{
    vector < int > st;
    for (int i = 1; i <= n; i ++)
        st.push_back(i);
    sub_block(st);
}
