#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2010;

int n;
int c[maxn][maxn];

int table[maxn][maxn];
int pref[maxn][maxn][2];
bool check_rectangle(int row1, int col1, int row2, int col2)
{
    for (int dx = 0; dx <= row2 - row1; dx ++)
        for (int dy = 0; dy <= col2 - col1; dy ++)
        {
            ///cout << dx << " : " << dy << endl;
            table[dx + 1][dy + 1] = c[row1 + dx][col1 + dy];
        }


    int h = row2 - row1 + 1;
    int w = col2 - col1 + 1;
    if (row2 > row1 && col2 > col1)
    {
        int sum1 = pref[row2 - 1][col2 - 1][1] - pref[row1][col2 - 1][1] - pref[row2 - 1][col1][1] + pref[row1][col1][1];
        if (sum1 > 0)
            return false;
    }
    for (int i = 0; i <= h + 1; i ++)
        table[i][0] = table[i][w + 1] = 1;
    for (int i = 0; i <= w + 1; i ++)
        table[0][i] = table[h + 1][i] = 1;

    int cor = 0;
    for (int i = 0; i <= h; i ++)
        for (int j = 0; j <= w; j ++)
        {
            int cnt = 0;
            if (table[i][j] == 0)
                cnt ++;
            if (table[i][j + 1] == 0)
                cnt ++;
            if (table[i + 1][j] == 0)
                cnt ++;
            if (table[i + 1][j + 1] == 0)
                cnt ++;
            if (cnt == 1)
                cor ++;
        }

    if (cor <= 4)
        return true;
    return false;
}

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        string row;
        cin >> row;
        for (int j = 1; j <= n; j ++)
        {
            c[i][j] = row[j - 1] - '0';
        }
    }

    for (int i = 0; i <= n + 1; i ++)
        c[i][0] = c[i][n + 1] = c[0][i] = c[n + 1][i] = 1;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        {
            pref[i][j][0] = pref[i - 1][j][0] + pref[i][j - 1][0] - pref[i - 1][j - 1][0];
            pref[i][j][1] = pref[i - 1][j][1] + pref[i][j - 1][1] - pref[i - 1][j - 1][1];
            int cnt = 0;
            if (c[i - 1][j - 1] == 0)
                cnt ++;
            if (c[i - 1][j] == 0)
                cnt ++;
            if (c[i][j - 1] == 0)
                cnt ++;
            if (c[i][j] == 0)
                cnt ++;
            if (cnt == 1)
                pref[i][j][0] ++;
            if (cnt == 3)
                pref[i][j][1] ++;
        }
    //cout << check_rectangle(1, 1, 3, 3) << endl;
    //exit(0);
    int ans = 0;
    for (int len = 1; len <= n; len ++)
    {
        bool tf = false;
        for (int x1 = 1; x1 <= n - len + 1; x1 ++)
        {
            int x2 = x1 + len - 1;
            for (int y1 = 1; y1 <= n; y1 ++)
            {
                int nec = ans / len;
                for (int y2 = max(y1, y1 + nec - 1); y2 <= n; y2 ++)
                {
                    if (check_rectangle(x1, y1, x2, y2))
                    {
                        ans = max(ans, (x2 - x1 + 1) * (y2 - y1 + 1));
                        tf = true;
                    }
                }
            }

        }
        //if (!tf)
        //  break;
    }
    cout << ans << endl;

}

int main()
{
    solve();
    return 0;
}
