#include<bits/stdc++.h>
using namespace std;

int const MAXN=2001;
int n, a[MAXN][MAXN], par_sum[MAXN][MAXN];
string s;

struct edge
{
    int l1, r1, l2, r2;
};

vector<edge> v;

void read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>s;
        for(int j=1;j<=n;j++)
        {
            a[i][j] = s[j-1] - '0';
        }
    }
}

int best(int l1, int r1, int l2, int r2)
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(l1 <= i && i <= r1 && l2 <= j && j <= r2) par_sum[i][j] = par_sum[i-1][j] + par_sum[i][j-1] - par_sum[i-1][j-1] + (a[i][j]^1);
            else par_sum[i][j] = par_sum[i-1][j] + par_sum[i][j-1] - par_sum[i-1][j-1] + a[i][j];
        }
    }
    int ans = 0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            for(int l=i;l<=n;l++)
            {
                for(int r=j;r<=n;r++)
                {
                    if(par_sum[l][r] - par_sum[i-1][r] - par_sum[l][j-1] + par_sum[i-1][j-1] == (l-i+1)*(r-j+1))
                    {
                        ans = max(ans, (l-i+1)*(r-j+1));
                    }
                }
            }
        }
    }
    return ans;
}

int solve()
{
    int ans = best(0, 0, 0, 0);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            par_sum[i][j] = par_sum[i-1][j] + par_sum[i][j-1] - par_sum[i-1][j-1] + a[i][j];
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            for(int l=n;l>=i;l--)
            {
                for(int r=n;r>=j;r--)
                {
                    if(par_sum[l][r] - par_sum[i-1][r] - par_sum[l][j-1] + par_sum[i-1][j-1] == 0)
                    {
                        v.push_back({i, j, l, r});
                        break;
                    }
                }
            }
        }
    }
    for(int i=0;i<v.size();i++)
    {
        ans = max(ans, best(v[i].l1, v[i].l2, v[i].r1, v[i].r2));
    }
    return ans;
}

int main()
{
    read();
    cout<<solve()<<endl;
    return 0;
}
